      subroutine set_ep_J2000 (idate)
      implicit real*8 (d)
      dimension idate(3)
      SAVE
      COMMON   /EJ2000/ DTUJD,DTUT20,DTDT20,DDT,ITY,ITM,ITD
      ity=idate(1)
      itm=idate(2)
      itd=idate(3)
      call julian (ity,itm,itd,dtujd)
      DTUT20=(DTUJD-2451545.0D0)/36525.0D0
      CALL TT_UTC_F (DTUJD,DDT)
      DTDT20=DTUT20+DDT/3155760000.0D0
      print '(a,i4,2i3.2,a,f10.1)'
     &,' <SetEpJ>>> J2000 epoch ',ity,itm,itd,', Julian date',DTUJD
      print '(2(a,f13.8),a,f8.3,a)'
     &,' <SetEpJ>>> J2000 UTC',DTUT20,' = TDT',DTDT20
     &,' Jcy, TDT-UTC=',DDT,' s'
      return
      end

      double precision function sec_from_ep_J2000 (idate,ihms)
      implicit real*8 (d)
      dimension idate(3),ihms(4)
      SAVE
      COMMON   /EJ2000/ DTUJD,DTUT20,DTDT20,DDT,ITY,ITM,ITD
      ity=idate(1)
      itm=idate(2)
      itd=idate(3)
      call julian (ity,itm,itd,dt)
      call tt_utc_f (dt,ddutc)
      dte=(dt-dtujd)*86400 +ddutc-ddt
      sec_from_ep_J2000=dte+ihms(4)/1d3+ihms(3)+(ihms(2)+ihms(1)*24)*60
      return
      end
      
      

      SUBROUTINE Astron_arg (DAS,DASP)
C----------------------------------------------------------------------C
C                                                                      C
C     From ROUTINE ETASTE, VERSION 900121 FORTRAN 77.                  C
C                                                                      C
C     === VERSION FOR IBM-AT ========================================  C
C                                                                      C
C     THE ROUTINE ETASTE COMPUTES THE ASTRONOMICAL ELEMENTS FOR        C
C     THE EPOCH IN COMMON /EJ2000/, J2000.0                            C
C                                                                      C
C     ALL VARIABLES DOUBLE PRECISION.                                  C
C                                                                      C
C     OUTPUT PARAMETER DESCRIPTION...                                  C
C     ===============================                                  C
C                                                                      C
C     DAS(1)...    MEAN MOONTIME IN DEGREE.                            C
C     DAS(2)...    MEAN LONGITUDE OF THE MOON IN DEGREE.               C
C     DAS(3)...    MEAN LONGITUDE OF THE SUN  IN DEGREE.               C
C     DAS(4)...    MEAN LONGITUDE OF THE PERIGEE OF THE MONN'S ORBIT   C
C                  IN DEGREE.                                          C
C     DAS(5)...    NEGATIVE MEAN LONGITUDE OF THE ASCENDING NODE OF    C
C                  THE MOON'S ORBIT IN DEGREE.                         C
C     DAS(6)...    MEAN LONGITUDE OF THE PERIGEE OF THE SUN'S ORBIT    C
C                  IN DEGREE.                                          C
C     DAS(7)...    PERIOD OF JUPITER'S OPPOSITION IN DEGREE (FOR       C
C                  TAMURA 1987 TIDAL POTENTIAL DEVELOPMENT).           C
C     DAS(8)...    PERIOD OF VENUS'S CONJUNCTION IN DEGREE (FOR        C
C                  TAMURA 1987 TIDAL POTENTIAL DEVELOPMENT).           C
C     DASP(1...8): TIME DERIVATIVES OF THE CORRESPONDING VARIABLES     C
C                  DAS IN DEGREE PER HOUR.                             C
C                                                                      C
C     USED ROUTINES...                                                 C
C     ================                                                 C
C                                                                      C
C     SUBROUTINE JULIAN_J2000 : JULIAN DATE.                           C
C     SUBROUTINE TDT_UTC : DIFFERENCE TDT - UTC.                       C
C                                                                      C
C     ROUTINE CREATION...    880130 BY H.-G.WENZEL,                    C
C                            GEODAETISCHES INSTITUT,                   C
C                            UNIVERSITAET KARLSRUHE,                   C
C                            ENGLERSTR. 7,                             C
C                            D-7500 KARLSRUHE 1,                       C
C                            FEDERAL REPUBLIC OF GERMANY.              C
C     ROUTINE MODIFICATION...900121 BY H.-G.WENZEL.                    C
C                            940203    H.-G.Scherneck                  C
C**********************************************************************C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION DAS(8),DASP(8)
      COMMON /EJ2000/ DTUJD,DTUT20,DTDT20,DDT,ITY,ITM,ITD
      COMMON /MPAR/ DPI,DRAD
      SAVE
      DATA HPJC/876600.d0/

C----------------------------------------------------------------------C
C     COMPUTE ASTRONOMICAL ELEMENTS FROM TAMURA 1987 FORMULAS.         C
C----------------------------------------------------------------------C
      print 7002, ity,itm,itd
      DPI=4.0D0*DATAN(1.0D0)
      DRAD=DPI/180.D0
      DT=DTUT20
      DT2=DTUT20**2
      DT3=DTUT20**3
      DAL=280.4606184D0 + 36000.7700536D0*DT + 0.00038793D0*DT2
     1 -0.0000000258D0*DT3
      DALP=(36000.7700536D0 +2.0D0*0.00038793D0*DT
     1 -3.0D0*0.0000000258D0*DT2)/(24.0D0*36525.D0)
      DT=DTDT20
      DT2=DTDT20**2
      DS=218.316656D0+481267.881342D0*DT-0.001330D0*DT2
      DSP=(481267.881342D0-2.0D0*0.001330D0*DT)/HPJC
      DH=280.466449D0+36000.769822D0*DT+0.0003036D0*DT2
      DHP=(36000.769822D0+2.0D0*0.0003036D0*DT)/HPJC
      DDS=0.0040D0*DCOS((29.D0+133.0D0*DT)*DRAD)
      DDSP=(-0.0040D0*133.0D0**DRAD*DSIN((29.D0+133.0D0*DT)*DRAD))/
     1 HPJC
      DDH=0.0018D0*DCOS((159.D0+19.D0*DT)*DRAD)
      DDHP=(-0.0018D0*19.0D0*DRAD*DSIN((159.D0+19.D0*DT)*DRAD))/
     1 HPJC
      DAS(1)=DAL-DS
      DAS(2)=DS+DDS
      DAS(3)=DH+DDH
      DAS(4)=83.353243D0 + 4069.013711D0*DT -0.010324D0*DT2
      DAS(5)=234.955444D0 +1934.136185D0*DT -0.002076D0*DT2
      DAS(6)=282.937348D0 + 1.719533D0*DT +0.0004597D0*DT2
      DAS(7)=248.1D0+32964.47D0*DT
      DAS(8)= 81.5D0+22518.44D0*DT

C----------------------------------------------------------------------C
C     COMPUTE THE SPEEDS IN DEGREE PER HOUR.                           C
C----------------------------------------------------------------------C
      DASP(1)=DALP-DSP+15.0D0
      DASP(2)=DSP+DDSP
      DASP(3)=DHP+DDHP
      DASP(4)=(4069.013711D0-2.0D0*0.010324D0*DT)/HPJC
      DASP(5)=(1934.136185D0-2.0D0*0.002076D0*DT)/HPJC
      DASP(6)=(1.719533D0+2.0D0*0.0004597D0*DT)/HPJC
      DASP(7)=32964.47D0/HPJC
      DASP(8)=22518.44D0/HPJC
      DO 110 I=1,8
      DAS(I)=DMOD(DAS(I),360.0D0)
      IF(DAS(I).LT.0.D0) DAS(I)=DAS(I)+360.0D0
  110 CONTINUE
  200 CONTINUE

C----------------------------------------------------------------------C
C     PRINT ASTRONOMICAL ELEMENTS.                                     C
C----------------------------------------------------------------------C
      print 7003
      print 7004, (K,DAS(K),DASP(K),K=1,8)
      RETURN

C----------------------------------------------------------------------C
C     FORMAT STATEMENTS.                                               C
C----------------------------------------------------------------------C
 7002 FORMAT (' <AstArg>>> Initial epoch ',I4,2I3)
 7003 FORMAT (' <AstArg>>> Theories: Moon Sun Jupiter Venus '
     &,       '- Tamura (1987)'
     &/       ' <AstArg>>>  Argument   Angle [deg]     Rate [deg/h]')
 7004 FORMAT (' <AstArg>>>     F',I1,3x,0p,f15.9,1p,D20.11)
      END

      SUBROUTINE JULIAN (ITY,ITM,ITD,DJULD)
C----------------------------------------------------------------------C
C                                                                      C
C     From ROUTINE ETJULD, VERSION 890119 FORTRAN 77.                  C
C                                                                      C
C     === VERSION FOR IBM-AT ===                                       C
C                                                                      C
C     THE ROUTINE ETJULD COMPUTES THE JULIAN DATE FROM YEAR,           C
C     MONTH, DAY, HOURS.                                               C
C                                                                      C
C     ALL VARIABLES WITH D AS FIRST CHARACTER ARE DOUBLE PRECISION.    C
C                                                                      C
C     INPUT PARAMETER DESCRIPTION...                                   C
C     ==============================                                   C
C                                                                      C
C     ITY...       YEAR  IN INTEGER FORM, E.G. 1971                    C
C     ITM...       MONTH IN INTEGER FORM, E.G. 1 = JANUARY.            C
C     ITD...       DAY   IN INTEGER FORM.                              C
C                                                                      C
C     OUTPUT PARAMETER DESCRIPTION...                                  C
C     ===============================                                  C
C                                                                      C
C     DJULD...     JULIAN DATE, E.G. FOR                               C
C                  01. JANUARY  1988, 0.00 H UTC IS DJULD=2447161.500  C
C                  01. FEBRUARY 1988, 0.00 H UTC IS DJULD=2447192.500  C
C                  29. FEBRUARY 1988, 0.00 H UTC IS DJULD=2447220.500  C
C                  01. MARCH    1988, 0.00 H UTC IS DJULD=2447221.500  C
C                                                                      C
C     EXECUTION TIME...                                                C
C     =================                                                C
C                                                                      C
C     ABOUT 0.0054 SEC CPU TIME FOR 1000 CALLS OF ETJULD ON CDC CYBER  C
C     990 OF RRZN HANNOVER USING OL=HIGH.                              C
C     ABOUT 1.43 SEC CPU TIME FOR 1000 CALLS OF ETJULD ON IBM-AT WITH  C
C     8087 COPROCESSOR USING WATFOR87 COMPILER.                        C
C                                                                      C
C     NUMERICAL ACCURACY...                                            C
C     =====================                                            C
C                                                                      C
C     THE RESULT ON IBM-AT IS ACCURATE TO 10**-7 DAYS WHICH IS         C
C     EQUIVALENT TO 0.01 SEC.                                          C
C                                                                      C
C     ROUTINE CREATION...    710523 BY H.-G.WENZEL,                    C
C                            GEODAETISCHES INSTITUT,                   C
C                            UNIVERSITAET KARLSRUHE,                   C
C                            ENGLERSTR. 7,                             C
C                            D-7500 KARLSRUHE 1,                       C
C                            FEDERAL REPUBLIC OF GERMANY.              C
C     ROUTINE MODIFICATION...890119 BY H.-G.WENZEL.                    C
C**********************************************************************C
      IMPLICIT DOUBLE PRECISION (D)
      DIMENSION DTM(12)
      SAVE
      DATA DTM/0.D0,31.D0,59.D0,90.D0,120.D0,151.D0,181.D0,212.D0,
     1 243.D0,273.D0,304.D0,334.D0/
     2, DTH/0.0D0/
      DJULD=2415019.5D0
      ITYR=ITY-1900
      LEAP=ITYR/4
      ITA=ITYR*365+LEAP
      IF(ITM.LT.1.OR.ITM.GT.12) GOTO 5010
      DJULD=DJULD+DBLE(ITA)+DTM(ITM)+DBLE(ITD)+DTH/24.D0
      ITYL=LEAP*4
      IF(ITYR.NE.ITYL) RETURN
C----------------------------------------------------------------------C
C     LEAP YEAR.                                                       C
C----------------------------------------------------------------------C
      IF(ITM.GT.2) RETURN
      DJULD=DJULD-1.D0
      RETURN
 5010 print 7050, ITY,ITM,ITD
      STOP
C----------------------------------------------------------------------C
C     FORMAT STATEMENTS.                                               C
C----------------------------------------------------------------------C
 7050 FORMAT(' <JULIAN>>> Month outside range:',2X,3I4)
      END

