C     -----------------------------
      real*8 function dpnmx (n,m,y)
C     -----------------------------
C Spherical harmonics * dPNM(cos(y))/dy for low n,m
C>
C     Derivative of PNM w r t angle A (=Y here), using recurrence formula,
C     the preferred method.
C_
      implicit real*8 (a-h,o-z)
      if (m.eq.0) then
         dpnmx=-pnm(n,m+1,y)
      else if (m.gt.n) then
         dpnmx=0.d0
      else if (m.eq.n) then
         c=dcos(y)
         x=dsin(y)
         if (dabs(x).lt.1.d-10) then
            dpnmx=0.d0
         else
            dpnmx=(n*c*pnm(n,m,y)-(n+m)*pnm(n-1,m,y))/x
         endif
      else
         dpnmx=((n+m)*(n-m+1)*pnm(n,m-1,y)-pnm(n,m+1,y))/2.d0
      endif
      return
      end
C
