      COMPLEX*16 FUNCTION DPOLAR(Z,ROUND)
C CMPX * Convert to polar, cut at ROUND
c
c To compute the amplitude in dB, call set_polar_db (.true.,eps)
c eps is a small-value floor., default = 1.d-20
c To leave it unchanged, call set_polar_db (.true.,-1.d0)
c
c skipped if ROUND is -540.0 and Z is real
c
      COMPLEX*16 Z
      REAL*8 X,Y,ROUND,DPHASE,EPS
      LOGICAL QDB
      COMMON /CDPOLAR/ EPS,QDB
      
      DATA QDB/.FALSE./, EPS/1.d-20/

      DPOLAR=Z
cp      Y=IMAGPART(Z) ! cx-new
      Y=DIMAG(Z) ! cx-old
      IF (DABS((DABS(ROUND+540.d0))+DABS(Y)).LE.1.d-60) RETURN 
      X=ABS(Z)
      IF (QDB) X=20.d0*DLOG10(DMAX1(EPS,X))
      Y=DPHASE(Z) 
      Y=DMOD(Y+ROUND,360.D0)-ROUND
      DPOLAR=DCMPLX(X,Y)
      RETURN
      END

      SUBROUTINE SET_POLAR_DB (QQ,X)
      LOGICAL QDB,QQ
      REAL*8 EPS,X
      COMMON /CDPOLAR/ EPS,QDB
      QDB=QQ
      IF (X.gt.0.d0) EPS=X
      RETURN
      END

      COMPLEX FUNCTION POLAR(Z,R)
C CMPX * Convert to polar, cut at R
      COMPLEX    Z
      COMPLEX*16 ZZ,ZV,DPOLAR
      REAL*8     ROUND
      ROUND=R
      ZZ=Z
      ZV=DPOLAR(ZZ,ROUND)
      POLAR=ZV
      RETURN
      END

      COMPLEX*16 FUNCTION DCARTES (Z)
C CMPX * Convert from polar to cartesian
      COMPLEX*16 Z
      REAL*8  RAD,X,EPS
      LOGICAL QDB
      COMMON /CDPOLAR/ EPS,QDB
      DATA    RAD/0.01745329251994/
      X=DREAL(Z)
      IF (QDB) X=10.d0**(X/20.d0)
      DCARTES=X*CDEXP((0.0d0,1.0d0)*RAD*DIMAG(Z))
      RETURN
      END

      COMPLEX FUNCTION CARTES (Z)
C CMPX * Convert from polar to cartesian
      COMPLEX Z
      REAL    RAD,X
      REAL*8  EPS
      LOGICAL QDB
      COMMON /CDPOLAR/ EPS,QDB
      DATA RAD/0.01745329/
      X=REAL(Z)
      IF (QDB) X=10.0**(X/20.0)
      CARTES=X*CEXP((0.0,1.0)*RAD*AIMAG(Z))
      RETURN
      END
C:Provides  complex*16 function dpolar(z,round) F=dpolar.f
C:Provides  complex function polar(z,r) F=dpolar.f
C:Provides  complex*16 function dcartes F=dpolar.f
C:Provides  complex function cartes F=dpolar.f
