      SUBROUTINE OPENF (IUNC)
C File utility * Open files, taking parameters from an INS-file
C>
C Documentation in /home/hgs/util/openf.cmt
c
c ABSOFT peculiarities:
c
c OPEN (...,READONLY,...)            is possible
c                                    options  R (ascii)  ^ (BIN)
c
c OPEN (...,POSITION='APPEND',...)   is necessary if data is to be appended
c                                    options  > (status unknown)  V (old)
c OPEN ( ..,POSITION='REWIND',...)   options  <    "       "      #   "
c
c OPEN (...,ENDIAN='BIG_ENDIAN' ENDIAN='LITTLE_ENDIAN' ...) is possible
c                                    option   % for big
c                                    (You have to change % to signify little
c                                    on a big-endian machine!)
c OPEN (...,BLOCK=-1  BLOCK=+1,...)  is possible (+1 for c-like binary files)
c                                    post-option character  `.'
c
c (How do you re-write *and* extend a late part of a file ???)
C_
      CHARACTER FN*80,OPT*1,FILS*8,QU*8,QN*3,QO*3,COMMNT*64,ANS*1
     &,         estr*64,ecmt*64,RSTR*256, SRSTR*80, PRMSG*(*)
     &,         PRMPTM*256, FNO*64, FILF*11, DFN*128, DN*64, EHOME*48
     &,         ENDIAN*16,INSFD*64,BC*1,SUU*2,BUFF*80, POSN*16, ACT*16
      LOGICAL   QPRMPT,QOPEN,QEXIST,QRONLY,QIA5,QEOF,QFS,QOR_INDEX
     &,         QRET1,qopene,qdbg,qtxtm
      include 'grex.fh'

      common /CIUF/ iufound
      SAVE
      
      DATA QU/'UNKNOWN'/,QN/'NEW'/,QO/'OLD'/,LH/-1/
     &,    INSFD/' '/, LI/0/, qdbg/.false./
     &,    LDN/0/                            ! Obs! new 2012 07 19
     &,    MSGL/0/                           ! Obs! new 2012 10 11
C
      QRET1=.FALSE.
      qopene=.false.
      estr=' '
      ecmt=' '
      IF (IUNC.LE.0.OR.IUNC.GT.99) THEN
         PRINT '(A,I10)',' <OPENF->T> Bad file unit number: ',IUNC
         STOP
      ENDIF
      call getenv ('openf_dbg',SRSTR)
      qdbg=SRSTR.ne.' '
      if (qdbg) then
         iudbg=99
         read (srstr,*,end=941,err=941) iudbg
      endif
 941  continue

      CALL GETENV ('tty',SRSTR)
      QIA5=SRSTR.NE.' '
1001  FORMAT (I2,1X,2A1,A)
1002  FORMAT (A,I2)
      QPRMPT=.FALSE.
      QEOF=.FALSE.
      NERR=0
      IUN=IUNC
      IUU=-1
      IUPR=5
      IUPW=6
      PRMPTM=' '
      SRSTR=' '
      RSTR=' '
      QFS=.FALSE.
C
C Position at a possible record: check columns 1-3 for 2-digit-number+blank
      IF (IUN.EQ.4) THEN
 601     READ (IUN,'(A)',END=609) RSTR
         CALL REPLACE_ENVARS_L (RSTR(1:128))
         IF (QDBG) WRITE (IUDBG,*) 'openf read:',RSTR
         L=INDEX_L_NONBLANK(RSTR)
         IF (RSTR(3:3).NE.' '.OR.RSTR(5:5).NE.' ') GOTO 601
         IF (INDEX(' -1234567890',RSTR(1:1)).LE.0) GOTO 601
         IF (INDEX(' 1234567890',RSTR(2:2)).LE.0) GOTO 601
         BACKSPACE (IUN)
         GOTO 11
 609     PRINT '(A)',' <OPENF->T> EOF while positioning file unit 4'
         IF (QEOF) STOP
         REWIND (IUN)
         QEOF=.TRUE.
         GOTO 601
      ENDIF
      GOTO 11

      ENTRY CLOSE_AGAIN
      READ (PRMPTM,'(I2)') IUFOUND
      CLOSE (IUFOUND)
      IF (MSGL.LE.2) PRINT '(A,I2,A)',' <CAgain>>> Unit ',i,' closed.'
      RETURN

      ENTRY WHAT_UNIT_OPENED (IUNC)
      READ (PRMPTM,'(I2)') IUNC
      RETURN
      
      ENTRY OPENF_MSGLEVEL (IUNC)
      MSGL=IUNC
      RETURN

      ENTRY OPENFS (PRMSG)
C File utility * Open files, using parameter string

      QRET1=.FALSE.
      QOPENE=.FALSE.
      ESTR=' '
      ECMT=' '
      GOTO 219

      ENTRY OPENFS_E (PRMSG,*)
C File utility * Open files, using parameter string + ERR branch

      QRET1=.TRUE.
      ESTR=' '
      ECMT=' '

 219  QFS=.TRUE.
      PRMPTM=PRMSG
      CALL GETENV ('openf_dbg',SRSTR)
      QDBG=SRSTR.NE.' '
      CALL REPLACE_ENVARS_L (PRMPTM)
      IUTERM=-1
      IUUB=-1
      IUN=-1
      QEOF=.FALSE.
      NERR=0

      IF (INDEX('## ??',PRMPTM(1:2)).GT.0) THEN
         DO I=10,99
            INQUIRE (UNIT=I,OPENED=QOPENE)
            IF (.NOT.QOPENE) THEN
               WRITE (PRMPTM(1:2),'(I2.2)') I
               IUFOUND=I
               GOTO 216
            ENDIF
         ENDDO
         GOTO 218
      ENDIF

 216  if (QRET1) THEN
         READ (PRMPTM(1:2),'(I2)',ERR=218,END=218) I
         IF (I.GT.0.AND.I.LE.99) THEN
            INQUIRE (UNIT=I,OPENED=QOPENE)
            IF (QOPENE) THEN
               CALL GET_FILE_NAME (I,ESTR)
               CALL GET_FILE_COMMENT (I,ECMT)
            ENDIF
         ELSE
            GOTO 218
         ENDIF
         GOTO 217
      ENDIF
      GOTO 217

 218  LPM=INDEX_L_NONBLANK(PRMPTM)
      PRINT '((A))'
     &,  ' <OpenfE>E> Argument string does not start with a file'
     &// ' unit number'
     &,  ' <OpenfE>I> ->'//prmptm(:lpm)//'<-'
      IF (QRET1) RETURN 1
      STOP

 217  QPRMPT=INDEX('pPtT',PRMPTM(4:4)).GT.0
      IF (QDBG) WRITE (IUDBG,*) 
     & 'openf: PRMPTM(4:4)=',PRMPTM(4:4),'::',PRMPTM
 118  IF (QPRMPT) THEN
         CALL OPEN_TERM (IUTERM)
         IF (IUTERM.EQ.5.OR.IUTERM.LE.0) THEN
            IUPR=5
            IUPW=6
         ELSE
            IUPR=IUTERM
            IUPW=IUTERM
         ENDIF
         READ (PRMPTM,*) IUU
      ELSE
         READ (PRMPTM,1001,ERR=119) IU,OPT,BC,RSTR
      ENDIF
      GOTO 11
 119  QPRMPT=.TRUE.
      IF (QDBG) WRITE (IUDBG,*) 'OPENF: activate prompt'
      PRMPTM(4:4)='P'
      GOTO 118
C
C
11    CALL GETENV ('HOME',EHOME)
      LH=INDEX(EHOME//' ',' ')-1
      CALL GET_FILE_NAME (IUN,INSFD)
      LI=INDEX_L(INSFD,'/')
C
C Prompt user if IUN=5 or OPT='P'
 1    CONTINUE
      IF (QDBG) WRITE (IUDBG,*) 
     &         '<openf->d> qprmpt,qfs,qia5,    iuu,iun,iupr='
     &,                    qprmpt,qfs,qia5,' ',iuu,iun,iupr
      IF (QPRMPT.AND.IUU.GT.0) THEN
         LPM=INDEX_L_NONBLANK(PRMPTM)
         LPMP=INDEX(PRMPTM,']')-1
         WRITE (IUDBG,*) 'OPENF:',lpm,lpmp,' ',prmptm(lpmp:)
         IF (LPMP.GT.0) LPM=LPMP
         IF (LPMP.GT.0.AND.INDEX(PRMPTM(LPMP+1:),' T').GT.0) THEN
            WRITE (SUU,'(I2.2)') IUU
            ier=text_mode(1)
            ier=clear_text()+new_text_surface()
            ier=crlf()+write_string(' <OPENF->!> '//PRMPTM(:LPM))
            ier=crlf()+write_string(' <OPENF->I> '//SUU//':O File_Name')
            ier=crlf()
            call screen_prompt(' <OPENF->?> '//SUU//':',BUFF)
            OPT=BUFF(1:1)
            RSTR=BUFF(4:)
c            READ (BUFF,'(A1,1X,A)') OPT,RSTR
         ELSE
            WRITE (IUPW,'(2A/A,I2,A,55(1H_)/A,I2,A,$)')
     &            ' <OPENF->!> ',PRMPTM(:LPM)
     &,           ' <OPENF->I> ',IUU,':O File_Name'
     &,           ' <OPENF->?> ',IUU,':'
            READ (IUPR,'(a)') RSTR
            CALL REPLACE_ENVARS_L (RSTR(1:128))
            OPT=RSTR(1:1)
            RSTR=RSTR(3:)
CCC            READ (IUPR,'(A1,1X,A)') OPT,RSTR
         ENDIF
         QPRMPT=INDEX(' *',OPT).LE.0
         IF (QDBG) WRITE (IUDBG,*) 'OPENF: activate prompt, opt=',OPT
         IF (INDEX(' *pPtT',OPT).GT.0) GOTO 1
         IU=IUU
      ELSEIF (.NOT.QFS) THEN
         IF ((IUN.EQ.5.AND.QIA5).OR.QPRMPT.AND.IUPR.NE.IUN) 
     &      WRITE (IUPW,'(A,55(1H_)/A,$)')
     &            ' <OPENF->I> IU O File_Name'
     &,           ' <OPENF->?> '
         IF (QPRMPT) THEN
            READ (IUPR,'(A)') RSTR
         ELSE
            READ (IUN,'(A)') RSTR
         ENDIF
         CALL REPLACE_ENVARS_L (RSTR(1:128))
         READ (RSTR,1001) IU,OPT,BC
         RSTR=RSTR(6:)
ccc            READ (IUPR,1001) IU,OPT,BC,RSTR
ccc         ELSE
ccc            READ (IUN,1001) IU,OPT,BC,RSTR
ccc         ENDIF
      ENDIF
      IBL=-1
      IF (BC.eq.'.') IBL=1

ccc      CALL REPLACE_ENVARS_L (RSTR)
      IF (((IUN.EQ.5.AND.QIA5).OR.QPRMPT).AND.OPT.EQ.'?') THEN
         IF (LDN.GT.0) THEN
            WRITE (IUPW,'(2A)') '  DIR=',DN(:LDN)
         ENDIF
         IL=INDEX(RSTR//' ',' ')-1
         IF (IL.GT.0) THEN
            INQUIRE (FILE=RSTR(:IL),EXIST=QEXIST)
            WRITE (IUPW,'(A,L2)') ' <OPENF->>> FileExists =',QEXIST
         ELSEIF (IU.GT.0.AND.IU.LT.100) THEN
            INQUIRE (UNIT=IU,OPENED=QOPEN)
            IF (QOPEN) THEN
               CALL GET_FILE_NAME (IU,FNO)
               LFNO=INDEX(FNO//' ',' ')-1
               WRITE (IUPW,'(3A)')
     &               ' <OPENF->>> Connected to ->',FNO(:LFNO),'<-'
            ELSE
               WRITE (IUPW,'(A)') ' <OPENF->>> Unit available.'
            ENDIF
            QOPEN=.FALSE.
         ENDIF
         GOTO 1
      ENDIF
C
      LRS=INDEX_L_NONBLANK(RSTR)
C
C OPT = C  - print as a comment
C
      IF (INDEX('cC',OPT).GT.0) THEN  
         if (msgl.le.1) PRINT '(2A)',' Comment>>> ',RSTR(:LRS)
         GOTO 1
      ENDIF
C
C OPT = S  - send a command to the system (short commands, please !)
C
      if (INDEX('sS',OPT).GT.0) THEN 
         IF (LDN.GT.0) THEN
            CALL SYSTEM ('cd '//DN(:LDN)//'; '//RSTR(:LRS))
            if (msgl.le.2) PRINT '(2a)'
     &,           ' <OPENF->>> $ ','cd '//DN(:LDN)//'; '//RSTR(:LRS)
         ELSE
            CALL SYSTEM (RSTR(:LRS))
            if (msgl.le.2) PRINT '(2a)',' <OPENF->>> $ ',RSTR(:LRS)
         ENDIF
         GOTO 1
      ENDIF
C
C OPT = H  - Help. List file /home/hgs/util/openf.cmt
C
      IF (INDEX('hH',OPT).GT.0) THEN
         CALL SYSTEM ('cut -c3-99 /home/hgs/util/openf.cmt')
         GOTO 1
      ENDIF
C
C OPT = * or L -  Don't process
C
      IF (INDEX('*lL',OPT).GT.0) GOTO 1
C
      IUUB=IUU
      IUU=-1
C
C OPT = P: Prepare user prompt for the next file
C
      IF (INDEX('pP',OPT).GT.0) THEN
         QPRMPT=.TRUE.
         if (qdbg) write (iudbg,*) 'openf: activate prompt due to "P"'
         PRMPTM=RSTR(:LRS)
         IUU=IU
         IF (IUU.LE.0) THEN
            IUPR=IUN
         ELSE
            IUPR=5
         ENDIF
         IUPW=6
         GOTO 1
      ELSEIF (INDEX('tT',OPT).GT.0) THEN
         QPRMPT=.TRUE.
         if (qdbg) write (iudbg,*) 'openf: activate prompt due to "Y"'
         PRMPTM=RSTR(:LRS)
         IUU=IU
         IUTERM=-1
         CALL OPEN_TERM (IUTERM)
         IF (IUTERM.GT.0.AND.IUTERM.NE.5) THEN
            IUPW=IUTERM
            IUPR=IUTERM
         ELSE
            IUPW=6
            IUPR=5
         ENDIF
         IF (IUU.LE.0) IUPR=5
         GOTO 1
      ENDIF
C
C QUIT  if OPT in 'Q_-@./'  or if IU < 1
C ABORT if OPT =  ']' in prompt mode. 
C ABORT if OPT =  '}' always. 
C
      IF ((QPRMPT.OR.(QIA5.AND.IUN.EQ.5)).AND.OPT.EQ.']'.OR.OPT.EQ.'}') 
     &   STOP '<OPENF->S>'
      IF (INDEX(' Qq_-@./',OPT).GT.0) GOTO 901
      IF (IU.LT.0) THEN
         PRINT '(a)',' <OPENF->>> Return due to IU=-1'
         GOTO 901
      ENDIF
C
C Take file name and comment
C
      IL=INDEX(RSTR//' ',' ')-1
      IL=MIN0(64,IL)
      FN=RSTR(:IL)
      ILC=INDEX_1_NONBLANK (RSTR(IL+2:)) +IL+1
      COMMNT=RSTR(ILC:)
      ILC=MAX0(1, INDEX_L_NONBLANK (COMMNT) )
C
C File name contains "?"
C
12    IQM=INDEX(FN,'?')
      IF (IQM.GT.0) THEN
         IUTERM=-1
         CALL OPEN_TERM (IUTERM)
         IF (IUTERM.GT.0) THEN
            IUPW=IUTERM
            IUPR=IUTERM
         ELSE
            IUPW=6
            IUPR=5
            IF (.NOT.QIA5) STOP 'Cannot interact'
         ENDIF
         LRS=INDEX_L_NONBLANK(RSTR)
         WRITE (IUPW,'(A,I2,1X,A1,1X,A)') 
     &         ' <OPENF->>> ',IU,OPT,RSTR(:LRS)
         WRITE (IUPW,'(3A,$)') ' <OPENF->?> Specify "?" in ',FN(:IL)
     &,        ' ->'
         READ (IUPR,'(A)') RSTR
         IR=INDEX(RSTR,' ')-1
         FN=FN(:IQM-1)//RSTR(:IR)//FN(IQM+1:IL)
         IL=INDEX(FN//' ',' ')-1
         IQM=INDEX(FN,'?')
         IF (IQM.GT.0) GOTO 12
         CALL REPLACE_ENVARS_U (FN)
      ENDIF      
C
C OPT = D: SET DIRECTORY
C
      IF (INDEX('Dd',OPT).GT.0) THEN
         IF (INDEX('.  ',FN(1:2)).GT.0) THEN
            DN=' '
            LDN=0
         ELSEIF (FN(1:1).EQ.'~') THEN
            IF (FN(1:2).EQ.'~/') THEN
               DN=EHOME(:LH)//FN(2:)
            ELSE
               DN='/home/'//FN(2:)
            ENDIF
            LDN=INDEX(DN//' ',' ')-1
            IL=LDN
         ELSEIF (FN(1:2).EQ.'&/') THEN
            DN=INSFD(:LI)//FN(3:)
            LDN=INDEX(DN//' ',' ')-1
            IL=LDN
         ELSEIF (FN(1:2).NE.'?') THEN
            DN=FN
            LDN=IL
         ENDIF
         IF (LDN.GT.0) THEN
            IF (DN(IL:IL).NE.'/') THEN
               LDN=LDN+1
               DN(LDN:)='/'
            ENDIF
         ENDIF
         if (msgl.le.2) PRINT '(2A,T54,3H - ,A)'
     &,        ' <OPENF->>> DIR  ',DN(:LDN),COMMNT(:ILC)
         IF (QPRMPT) IUU=IUUB
         GOTO 1
      ENDIF   
      IF (INDEX('Nn+',OPT).GT.0) THEN
C
C OPT = N: Status NEW
C
         FILS=QN
      ELSE IF (INDEX('OoRrEeVv^#%',OPT).GT.0) THEN
C
C OPT = { O E V }: Status OLD  E: append to ASCII-file;
C                              V: append to binary file
C                              v: like V but big endian
C
         FILS=QO
      ELSE
C
C Any other option: Status = Unknown
C
         FILS=QU
      ENDIF
C
C Readonly:
C
      QRONLY=INDEX('rR^',OPT).GT.0
C
C Select form
C
      IF (INDEX('<+#%UuVv^>',OPT).GT.0) THEN
         FILF='UNFORMATTED'
      ELSE
         FILF='FORMATTED'
      ENDIF
C
C Select position
C 
      IF (INDEX('eEaAVv>',OPT).GT.0) THEN
         POSN='APPEND'
      ELSE
         POSN='REWIND'
      ENDIF
C
C Select conversion (note that big endian + append is impossible!)
c Let's try with "v" 
c 
C
      IF (INDEX('%v',OPT).gt.0) THEN
         ENDIAN='BIG_ENDIAN'
      ELSE
         ENDIAN='LITTLE_ENDIAN'
      ENDIF
C
C Process:
C (1) Check whether the file is already open
102   INQUIRE (UNIT=IU,OPENED=QOPEN)
C
C if yes, inform the user and ask whether Close with Endfile
C (Let's hope the user knows what he/she's doing; it's harmless if the
C append option was active / if the file has been written complete)
C
      IF (QOPEN.AND.((QIA5.AND.IUN.EQ.5).OR.QPRMPT)) THEN
         CALL GET_FILE_NAME (IU,FNO)
         WRITE (IUPW,'(2A/A,I2,A,$)')
     &         ' <OPENF->W> Already open: ',FNO
     &,        ' <OPENF->?> Rewind Close End_file Prompt_again'
     &,         IU,' (R/C/E/P):'
         READ (IUPR,'(A1)') ANS
         IF (INDEX('eE',ANS).GT.0) THEN
            ENDFILE (IU,ERR=103)
         ELSE IF (INDEX('cC',ANS).GT.0) THEN
            CLOSE (IU)
            WRITE (IUPW,1002) ' <OPENF->>> Close ',IU
            QOPEN=.FALSE.
         ELSE IF (INDEX('rR',ANS).GT.0) THEN
            REWIND (IU)
            WRITE (IUPW,1002) ' <OPENF->>> Rewind ',IU
            GOTO 1
         ELSEIF (INDEX('pP',ANS).GT.0) THEN
            IF (IUN.NE.5) THEN
               QPRMPT=.TRUE.
               IUU=IUUB
               if (qdbg) write (iudbg,*) 'openf: activate prompt, ans=P'
            ENDIF
            GOTO 1
         ELSE
            WRITE (IUPW,'(A)') ' <OPENF->W> Ignored. Try again ...'
            GOTO 1
         ENDIF
      ENDIF
104   IF (QOPEN) THEN
C
C No user interaction: The file must be closed
C
         CLOSE (IU)
         if (msgl.le.2) PRINT 1002,' <OPENF->>> Close ',IU
      ENDIF
C
C (2) Now, open the file:
      IF (FN(1:2).EQ.'./') THEN
         DFN=FN(3:)
      ELSEIF (FN(1:1).EQ.'~') THEN
         IF (FN(1:2).EQ.'~/') THEN
            DFN=EHOME(:LH)//FN(2:)
         ELSE
            DFN='/home/'//FN(2:)
         ENDIF
      ELSEIF (FN(1:2).EQ.'&/') THEN
         DFN=INSFD(:LI)//FN(3:)
      ELSEIF (FN(1:1).NE.'/'.AND.LDN.GT.0) THEN
         DFN=DN(:LDN)//FN
      ELSE
         DFN=FN
      ENDIF
      LFLS=INDEX_L_NONBLANK(FILS)
      LFLF=INDEX_L_NONBLANK(FILF)
      LDFN=INDEX_L_NONBLANK(DFN)
      IF (QRONLY) THEN
         IF (FILF(1:2).eq.'UN') then
            OPEN (UNIT=IU,FILE=DFN,STATUS=FILS,ACCESS='SEQUENTIAL'
     &        ,     FORM=FILF ! , readonly ! unsupported by g77
     &        ,     CONVERT=ENDIAN  !,BLOCK=IBL
     &        ,     ERR=101,IOSTAT=IERSTAT)
         ELSE
            OPEN (UNIT=IU,FILE=DFN,STATUS=FILS,ACCESS='SEQUENTIAL'
     &        ,     FORM=FILF ! , readonly ! unsupported by g77
     &        ,     ERR=101,IOSTAT=IERSTAT)
         ENDIF
         IF ((QIA5.AND.IUN.EQ.5).OR.QPRMPT) THEN
            if (msgl.le.2) PRINT '(A,I2,5(1X,A))'
     &,           ' <OPENF->1> ',IU,OPT,DFN(:LDFN),FILS(:LFLS)
     &,            FILF(:LFLF) ! ,'READONLY'
         ENDIF
      ELSE
         if (qdbg) PRINT '(A,I2,5(1X,A))'
     &,           ' <OPENF->d> ',IU,OPT,DFN(:LDFN),FILS(:LFLS)
     &,            FILF(:LFLF)
         IF (FILF(1:2).eq.'UN') then
c            print *,'<openf->d> ',fils,' ',filf,' ',posn,' ',endian
            OPEN (UNIT=IU,FILE=DFN,STATUS=FILS,ACCESS='SEQUENTIAL'
     &        ,     FORM=FILF,POSITION=POSN
     &        ,     CONVERT=ENDIAN     !  ,BLOCK=IBL
     &        ,     ERR=101,IOSTAT=IERSTAT)
         ELSE
            if (msgl.le.1) print *,'<openf->>> sequential ',iu,' '
     &,             filf,' ',fils ! ,' ',posn
            OPEN (UNIT=IU,FILE=DFN,STATUS=FILS,ACCESS='SEQUENTIAL'
     &        ,     FORM=FILF  ! ,POSITION=POSN
     &        ,     ERR=101,IOSTAT=IERSTAT)
            if (msgl.le.1) print *,'<openf->>> ',iu,' done'
         ENDIF
         IF ((QIA5.AND.IUN.EQ.5).OR.QPRMPT) THEN
            if (msgl.le.2) PRINT '(A,I2,5(1X,A))'
     &,           ' <OPENF->2> ',IU,OPT,DFN(:LDFN),FILS(:LFLS)
     &,            FILF(:LFLF)
         ENDIF
      ENDIF
      LFB=INDEX(FN//' ',' ')-1
      LFC=64-LFB-1
      CALL SAVE_FILE_NAME (IU,FN(:LFB)//' '//COMMNT(:LFC))
C
C OPT = { A E U V > }: Skip to end (first EOF-mark).
      RSTR=FN(:IL)
      ILL=MAX0(40,IL+5)
      RSTR(ILL:)=COMMNT
      CALL REPLACE_IN_STRING (RSTR,'!',' ',1,0)
c      IF (INDEX('AaeEuUvV>',OPT).GT.0) THEN
      IF (INDEX('AaeE',OPT).GT.0) THEN
         RSTR(ILL-3:ILL-1)='>> '
         CALL SKIP_TO_END (IU,OPT)  ! Let's try with OPEN (...,POSITION=POSN)
      elseif (index('UuVv>',OPT).gt.0) then
         rstr(ill-3:ill-1)=' > '
      ELSE
         RSTR(ILL-3:ILL-1)=' - '
      ENDIF
      ILF=INDEX(RSTR,' ')
      ILL=INDEX_L_NONBLANK(RSTR)
      IF (.NOT.((QIA5.AND.IUN.EQ.5).OR.QPRMPT)) THEN
         if (msgl.le.2) PRINT '(A,I2.2,1H:,A1,1X,A)'
     &,        ' <OPENF->3> ',IU,OPT,RSTR(:ILL)
         IF (msgl.le.2.and.QOR_INDEX(COMMNT,'!?',IDUM)) 
     &      PRINT '(A,5H  =  ,A)'
     &,           ' <OPENF->4> ',DFN(:LDFN)
      ENDIF
      IF (QFS) RETURN

      QPRMPT=.FALSE.
      GOTO 1
C
901   IF (NERR.GT.0.AND.IUN.NE.5) THEN
         PRINT '(A,I3)',' <OPENF->T> Error count:',NERR
         STOP
      ENDIF
      RETURN
C
C That's for the regular section.
C
C Now let's deal with errors and problems:
C (1) ERR branch taken at OPEN
C
101   CONTINUE
      ANS='E'
      IF (QFS) ANS='T'
      IF (QRET1) ANS='E'
      LDFN=INDEX_L_NONBLANK(DFN)
      PRINT '(3A,I2,1X,A1,4A,i5,a,L1)'
     &,     ' <OPENF->',ANS,'> ',IU,OPT,' File ->',FN(:IL)
     &,     '<- Status=',FILS,IERSTAT,' READONLY=',QRONLY
      PRINT '(3A)',' <OPENF->I> DFN ->',DFN(:ldfn),'<-'
      IF (QRET1) then
         les=index_l_nonblank(estr)
         lee=index_l_nonblank(ecmt)
         if (qopene.or.les.gt.0) 
     &      print '(a,l2,4a)'
     &,           ' <OpenfE>I> Previously open:',qopene
     &,           ' ->',estr(:les),'<->',ecmt(:lec),'<-'
         IF (QFS) RETURN 1
      ENDIF
      IF (QFS) STOP
      IF (QPRMPT.OR.(QIA5.AND.IUN.EQ.5)) THEN
         LPM=INDEX_L_NONBLANK(PRMPTM)
         IF (IUN.EQ.5) THEN
            PRMPTM='OPEN failed.'
            LPM=12
         ENDIF
         WRITE (IUPW,'(2A)') ' <OPENF->I> Attention: ',PRMPTM(:LPM)
         WRITE (IUPW,'(A,$)')
     &' <OPENF->?> Enter: (A)bort (R)etry (I)gnore (P)rompt_again:'
         READ  (5,'(A1)',ERR=901,END=901) ANS
         WRITE (IUPW,'(1H )')
         IF (INDEX('Aa',ANS).GT.0) STOP
         IF (INDEX('Rr',ANS).GT.0) THEN
c            NERR=NERR-1
            GOTO 102
         ENDIF
         IF (INDEX('Ii',ANS).GT.0) GOTO 1
         IF (INDEX('Pp',ANS).GT.0) THEN
c            NERR=NERR-1
            IF (IUN.NE.5) THEN
               IUU=IUUB
               IUPR=5
               QPRMPT=.TRUE.
               if (qdbg) write (iudbg,*) 'openf: activate prompt xx'
            ENDIF
            GOTO 1
         ENDIF
      ELSE
         NERR=NERR+1
      ENDIF
      QPRMPT=.FALSE.
      GOTO 1
C
C (2) ERR at ENDFILE
C
103   PRINT '(A)',' <OPENF->E> End file failed/denied.'
      NERR=NERR+1
      GOTO 104
      END

      INTEGER FUNCTION IUN_OPENF ()
      COMMON /CIUF/ IUFOUND
      IUN_OPENF=IUFOUND
      RETURN
      END
C:Provides  subroutine openf F=openf.f
C:Provides  entry openfs F=openf.f
C:Provides  entry openfs_e F=openf.f
