      REAL*8 FUNCTION DPHASE(Z)
C CMPX * Return Phase in degrees
      COMPLEX*16 Z,ZC
      REAL*8 RAD,DFATG
      DATA RAD/0.0174532925199/
      ZC=Z
      DPHASE=DMOD(DFATG(ZC)/RAD+360.D0,360.D0)
      RETURN
      END


      DOUBLE PRECISION FUNCTION DFATG (Z)
C CMPX * Returns ARG in rad
C
C ARC TAN OF (IM(Z) / RE(Z)) for complex*16 argument
C SFATG is the equivalent function, accepting complex*8 argument.
C The result is in radians.
C As an improvement to (D)ATAN2, +- PI/2 are returned if the real part
C of the argument is very small / zero.
C
      COMPLEX*16 Z
      REAL*8 D,IM,RE,DIM,DRE,PI
      DATA PI/3.14159265358979/
c      IM=IMAGPART(Z) ! cx-new
c      RE=REALPART(Z) ! cx-new
      IM=DIMAG(Z) ! cx-old
      RE=DREAL(Z) ! cx-old
      DIM=DABS(IM)
      DRE=DABS(RE)
      IF (DIM.LT.1.D-40.AND.DRE.LT.1.D-40) THEN
         D=0.D0
         GOTO 1
      ENDIF
      IF (DRE.LT.1.D-12*DIM) THEN
         IF (IM.GT.0.) THEN
            D=PI/2.D0
         ELSE
            D=-PI/2.D0
         ENDIF
         GOTO 1
      ENDIF
      IF (DIM.LT.1.D-12*DRE) THEN
         IF (RE.GT.0.D0) THEN
            D=0.D0
         ELSE
            D=PI
         ENDIF
         GOTO 1
      ENDIF
      D=DATAN2(IM,RE)
      IF (D.GT.PI) D=D-2.D0*PI
1     DFATG=D
      RETURN
      END

      FUNCTION SFATG (Z)
C CMPX * Returns ARG in rad
C
C ARC TAN OF (IM(Z) / RE(Z)) for complex*8 argument
C The result is in radians.
C As an improvement to ATAN2, +- PI/2 are returned if the real part
C of the argument is very small / zero.
C
      COMPLEX Z
      REAL*8 D,IM,RE,DIM,DRE,PI
      DATA PI/3.14159265358979/
c      IM=IMAGPART(Z) ! cx-new
c      RE=REALPART(Z) ! cx-new
      IM=AIMAG(Z) ! cx-old
      RE=REAL(Z) ! cx-old
      DIM=DABS(IM)
      DRE=DABS(RE)
      IF (DIM.LT.1.D-40.AND.DRE.LT.1.D-40) THEN
         D=0.D0
         GOTO 1
      ENDIF
      IF (DRE.LT.1.D-12*DIM) THEN
         IF (IM.GT.0.) THEN
            D=PI/2.D0
         ELSE
            D=-PI/2.D0
         ENDIF
         GOTO 1
      ENDIF
      IF (DIM.LT.1.D-12*DRE) THEN
         IF (RE.GT.0.D0) THEN
            D=0.D0
         ELSE
            D=PI
         ENDIF
         GOTO 1
      ENDIF
      D=DATAN2(IM,RE)
      IF (D.GT.PI) D=D-2.D0*PI
1     SFATG=D
      RETURN
      END

C:Provides  function sfatg F=phase.f
C:Provides  real*8 function dphase(z) F=phase.f
C:Provides  complex*16 function dpolar(z,round) F=phase.f
C:Provides  complex function polar(z,r) F=phase.f
C:Provides  double precision function dfatg F=phase.f
