      subroutine pos_header_c (iut,iuh_c,iuo_c,ich_c)
c
c iut - file unit for table, input/output (!)
c       If header exists and ICH=1, then it will be copied.
c       iut will return the file unit from which the header was taken. 
c iuh - file unit for header, input. If IUT does not contain a header or
c       if ICH=2 then this file is copied into iuo
c       IUH < 1: don't process
c iuo - output file unit.
c       IUO < 0: don't make output
c
      character buff*80,cols*80
      logical qc,qhf,qop
      common /cposh/ qhf
      common /ccposh/ cols
      save /cposh/, /ccposh/
      
2101  format (a)
      iuh=iuh_c
      iuo=iuo_c
      ich=ich_c
      if (iut.le.0) iut=iuh
      if (iuh.gt.0) then
         inquire (unit=iuh,opened=qop)
         if (.not.qop) iuh=-1
      endif
      if (iuo.gt.0) then
         inquire (unit=iuo,opened=qop)
         if (.not.qop) iuo=-1
      endif
      if (ich.eq.2.and.iuh.lt.0) ich=-1
      if (ich.gt.0.and.iuo.lt.0) ich=-1
      goto 1

      entry pos_header (iut)
      iuh=-1
      iuo=-1
      ich=-1

1     qc=iuo.le.0                          ! one pass if no output file
      qhf=.false.
10    read (iut,2101,end=90) buff
      if (qc.and.iuo.gt.0.and.ich.eq.1) then        ! copy header 2'nd pass
         ls=index_l_nonblank(buff)
         write (iuo,2101) buff(:ls)
      endif
      i=index(buff,'AMPFAC')+8
      if (i.gt.8) then
         read (buff(i:),*) ampfac
         call get_ol_ampfac (ampfac)
      endif

      i=index(buff,'COLUMN ORDER:')+13
      if (i.gt.13) then
         cols=buff(i:)
      endif
      if (index(buff,'$$ END HEADER').le.0) goto 10
      qhf=.true.
      if (qc.and.iuo.gt.0.and.ich.eq.2) goto 91
      lb=index_l_nonblank(buff)
c      if (qc) print '(2a)',' <PosHea>>> o.k., ',buff(:lb)
      if (qc) return              ! it's a headered file, copy = o.k.
      qc=.true.
      rewind (iut)
      goto 10
c
c Optionally copy header from unit 20
90    rewind (iut)
91    if (iuh.le.0.or.iuo.le.0) return
      inquire (unit=iuh,opened=qc)
      if (qc) then
         iut=iuh
         ich=1
         goto 10
      endif
      close (iuh)
      return
      end

      integer function ncolumn_olfile (sy)
      character sy*(*),cols*80
      common /ccposh/ cols
      save /ccposh/
      ls=min0(len(sy),4)
      n=index(cols,sy(:ls))
      if (n.gt.0) n=n/4+1
      if (n.le.0) print *,' ncolumn_olfile: C >',cols,'<'
      if (n.le.0) print *,' ncolumn_olfile: S >',sy,'<'
      ncolumn_olfile=n
      return
      end

      logical function q_pos_header ()
      logical qhf
      common /cposh/ qhf
      save /cposh/
      q_pos_header=qhf
      return
      end

C:Provides  subroutine pos_header_c F=poshead.f
C:Provides  integer function ncolumn_olfile F=poshead.f
C:Provides  entry pos_header F=poshead.f
