      subroutine re_gravity_tide (rs,ys,xs,dpsiu,zg)
c
c rs   - real*8 - site geocentric radius [m]
c ys   - real*8 - site colatitude [rad]
c xs   - real*8 - site longitude [rad]
c dpsi - real*8 - angle Geographic - Geocentric Latitude
c                 Specify an insane value and the routine will compute it.
c                 This parameter is input only, so you can specify a stupid 
c                 constant, e.g. -99.d0
c
c zg - comlex*16 - gravity spectrum, returned
c
      implicit real*8 (a-h,o-y), complex*16 (z)
      dimension zg(*),p(2:5,0:5),dp(2:5,0:5),zl(0:5),rr(2:5)

      COMMON /EPAR/   R0,RE,GE,EROT,BL(3),GM,GRVLAT,ESQUAR,FE,BG,RHOW
      COMMON /MPAR/   PI,RAD

      common /castsp/ amp(1200),pha(1200),fre(1200),nv,iaa(0:9,1200)
      integer*2 iaa

      data zi/(0.0d0,1.0d0)/

      dpsi=dpsiu
      if (dpsi.le.-.5d0.or.dpsi.gt.1.d0) 
     &   dpsi=datan(1.d0/(1.d0-esquar)*dtan(pi/2.d0-ys))+ys-pi/2.d0
      cpsi=dcos(dpsi)
      spsi=dsin(dpsi)

      do n=2,5
         do m=0,n
            p(n,m)=pnm(n,m,ys)
            dp(n,m)=dpnmx(n,m,ys)
         enddo
      enddo
      do m=0,5
         zl(m)=exp(zi*xs*dfloat(m))
      enddo
      do n=2,5
         rr(n)=1.d9/rs*(rs/re)**n
      enddo

      do i=1,nv
         n=iaa(0,i)
         m=iaa(1,i)
         if (n.le.5.and.m.le.n) then
            zg(i)=amp(i)*exp(zi*pha(i))*zl(m)
     &           *rr(n)*(-n*cpsi*p(n,m)+spsi*dp(n,m))
         else
            zg(i)=(0.d0,0.d0)
         endif
      enddo
c
c Formula: -grad pot = - n*P/r * cos(N) + (-dP/dang)/r * (-sin(N))
c 
      print '(a,f10.1,2f10.4/a,f10.4)'
     &,     ' <ReGraT>>> Rigid Earth Gravity at loc ',rs,ys/rad,xs/rad
     &,     ' <ReGraT>>> Dpsi=',dpsi/rad
      call blmult ('NO')
      return
      end

