      logical function epoch_set ()
c
c These epoch related subprograms should now (2012-07-05) be able
c to process leap-seconds. 
c The definition of the leap seconds is in th data statement of
c Function Leap_Second
c
      logical qes
      common /ctime/ iep(3),julbas,lsep,qes
      epoch_set=qes
      return
      end

      integer function juldat_epoch ()
      logical qes
      common /ctime/ iep(3),julbas,lsep,qes
      if (qes) then
         juldat_epoch=julbas
      else
         juldat_epoch=-1
      endif
      return
      end

      subroutine set_epoch (date)
      integer date(3),mdate(3)
      real*8 t
      logical qes,qdbg,qpr
      common /ctime/ iep(3),julbas,lsep,qes
      common /cufios/ qdbg,qpr
      data mdate/2100,12,31/
      
      ml=msglevel_ts(-999)
      if (ml.lt.1) print *,'<SetEpo>>> Called for ',date
      if (date(1).le.0) then
         if (ml.le.3) print '(a,i4,3i3.2)'
     &,     ' <SetEpo>W> Ignoring a date like ',date
         return
      endif
      if (date(1).ge.0.and.date(1).le.mdate(1)+1) then
         if (date(1).lt. 50) date(1)=date(1)+2000
         if (date(1).lt.100) date(1)=date(1)+1900
         julbas=juldat(date)
         call datjul(julbas,iep)
         qes=.true.
      else
         qes=.false.
      endif

      if (.not.qes) then
         if (ml.le.4) 
     &      print '(a,i5,2i3.2)',' <SetEpo>E> Illegal date :',date
      else
         julbas=juldat(iep)
c 1       lsep=leap_second_jul(julbas,isls)
         lsep=0
         if (ml.le.2) 
     &   print '(a,i4,2i3.2,a,i5,a,i3)'
     &,' <SetEpo>>> ',iep,', JUL=',julbas,' LeapSec:',lsep
      endif
      return

      entry drop_epoch ()
      ml=msglevel_ts(-999)
      qes=.false.
      if (ml.le.2) print '(a)',' <DropEp>>> Forgetting about the epoch.'
      return

      entry new_epoch (t)
      ml=msglevel_ts(-999)
      if (qes) then
         julinc=idint(t/24.d0)
         julbas=julbas+julinc
         call datjul (julbas,iep)
         t=t-julinc*24.d0
         if (ml.le.2) 
     &      print '(a,i4,2i3.2,a,i5)'
     &,           ' <NewEpo>>> ',iep,', JUL=',julbas
      endif
      return

      entry get_epoch (date)
      ml=msglevel_ts(-999)
      if (.not.qes) then
         if (ml.le.4)
     &      print '(a)',' <GetEpo>E> Epoch not set.'
         date(1)=-1
         return
      endif
      date(1)=iep(1)
      date(2)=iep(2)
      date(3)=iep(3)
      return
      end


      integer function leap_second (date,isls)
c
c To switch the feature off, ier=leap_second_scan(0)
c
c Returns the accumulated leap seconds for the specified date
c (For practical reasons, we start in 2012-06-30 since we have
c no data spanning earlier leap-second events)
c 
c date(3) - integer - input: YYYY MM DD
c isls    - integer - returned: 1 if the day has a leap-second event
c                               0 otherwise
c
c ENTRIES:
c leap_second_jul (mjd, isls) - the same but with the Mod.Julian date as
c                               input
c  
c is_leap_second_jul (mjd)    - for query, returns the isls result
c
c leap_second_scan (n)        - to switch leap-second processing on/off
c                               (or shorten the scan width of the
c                               l.s. date array); see below.
c
      parameter (maxleaps=50, maxls2=maxleaps-2)
      dimension date(3),fdate(3),julls(maxleaps),leaps(maxleaps)
      data julls/56108,57203,maxls2*90000/, leaps/1,1,maxls2*0/, nls/3/
      integer date,fdate
      logical qe, epoch_set, q1, qq, qclose,qopiun
      character fn*(*),dfn*128, ufn*128, str*32

      data dfn/'/home/hgs/Ttide/etgtab/ttutcf.dat'/, qclose/.true./
      
      leap_second=0
      ml=msglevel_ts(-999)
      if (nls.le.0) then
         if (ml.lt.1) print *,'<LeaSec>>>',nls,' leap_seconds: IGNORE '
         return
      endif
      qe=.false.
      jul=juldat(date)
      goto 1
      
      entry leap_second_jul (jj,isls)
      ml=msglevel_ts(-999)
      leap_second_jul=0
      if (nls.le.0) then
         if (ml.lt.1) print *,'<LeaSeJ>>>',nls,' leap_seconds: IGNORE'
         return
      endif
      jul=jj
      qe=.true.

 1    ls=0
      isls=0
      do i=1,nls
         if (jul.gt.julls(i)) then
            ls=ls+leaps(i)
            if (ml.lt.1) print *,'<LeaSeJ>>> jul,i,julls,leaps,ls:'
     &, jul,i,julls(i),leaps(i),ls
         elseif (jul.eq.julls(i)) then
            isls=1
            goto 101
         else
            goto 101
         endif
      enddo
      
 101  if (ml.lt.1) 
     & print *,'<LeaSec>>> leap_seconds returning ',ls
      if (qe) then
         leap_second_jul=ls
      else
         leap_second=ls
      endif
      return
      
      entry is_leap_second_jul (jj)
      do i=1,nls
         if (jj.eq.julls(i)) then
            is_leap_second_jul=1
            return
         endif
      enddo
      is_leap_second_jul=0
      return

      entry leap_second_scan (jj)
c
c query or reset:
c jj <  0: the scan width of the leap-second array is returned
c jj >= 0: the scan width is set to jj (currently max is MAXLEAPS)
c          and the previous scan width is returned
c 
      ml=msglevel_ts(-999)
      i=nls
      if (jj.ge.0) nls=min0(maxleaps,jj)
      if (ml.lt.3) print *,'<LeaSeS>>> leap_second_scan: NLS=',nls
      leap_second_scan=i
      return

      entry leap_seconds_from_file (iun,fn,qq)
c
c Using e.g. ~/Ttide/etgtab/ttutcf.dat to replace the default 
c leap-second array:
c
c We store the leap seconds after the current epoch. Usually one or
c zero events. The minimum leap-second array would contain one very far-
c future event. An early epoch has the consequence of slowing the
c program speed a little. Missing is still an option to topple
c the leap-second array.
c 
c If no epoch has been set, if we then would import all leap seconds in
c the ttutcf.dat file, the result would be in error except if we set 
c the epoch to something in the 1970-ies. Therefore, if the epoch has 
c not been set, we must abort.
c
c Missing is still a capability to edit the default settings. Until
c next time the IERS is going to bother us. 
c 
      qclose=qq
      print *,'<leapsff>>> qclose,fn=',qclose,' ->',trim(fn),'<-'
      ml=msglevel_ts(-999)
      if (.not.epoch_set()) then
         print '(a)',' <LeapSF>T> Only after an epoch has been set!'
         stop 'No Epoch in effect. Routine was sasu01.f'
      endif
      julep=juldat_epoch()

      if (iun.gt.0) then
         if (fn(1:1).ne.' ') dfn=fn
         inquire (unit=iun,opened=qopiun)
         if (qopiun) then
            rewind (iun)
         else
            if (fn(1:1).ne.' ') dfn=fn
            ufn='?? R '//dfn
            write (ufn(1:2),'(i2)') iun
            call openfs_e (ufn,*898)
         endif
      else
         dfn=fn
         call openfs_e ('?? R '//dfn,*898)
         iun=iun_openf()
      endif

      nls=0
      lfn=index_l_nonblank(dfn)
      if (ml.lt.1) print *,'<LeaSFF>>> Reset, file=',dfn(:lfn)
      if (ml.lt.1) print *,'<LeaSFF>>> Reset, Jul Epoch: ',julep

 801  read (iun,'(a)') str
      if (ml.lt.1) print *,'<leapsf>d> read ->',trim(str),'<-'
      if (index_l_nonblank(str).lt.10) goto 899
      read (str,'(i4,4i3)') fdate,lsf
      if (ml.lt.1) print *,'<leapsf>d> fdate,lsf=',fdate,lsf
      if (fdate(1).lt.0.or.fdate(1).gt.3000) goto 899
      jd=juldat(fdate)
      if (jd.lt.julep) goto 801
      nls=nls+1
      julls(nls)=jd
      leaps(nls)=lsf
      if (ml.lt.1) print *,'<LeapSF>>> nls,julls,leaps='
     &, nls,julls(nls),leaps(nls)
      goto 801

 899  if (ml.lt.1) print *,'<leapsf>d> qclose,iun=',qclose,iun
      if (qclose) close (iun)
      if (nls.gt.0) then
         call datjul(julls(nls),fdate)
         if (ml.lt.2) print '(a,i3,2a,i4,2i3.2)'
     &,   ' <LeapSF>>> ',nls,' leap-second events read,'
     &,   ' last event: ',fdate
      else
         if (ml.lt.2) print '(a,i6)'
     &,   ' <LeapSF>>> Nice! No leap-second events after the epoch '
     &,   julep
      endif
      nls=nls+1
      if (ml.lt.1) print *,'<leapsf>d> nls',nls
      if (ml.lt.1) print *,'<leapsf>d> julls',julls(nls)
      call datjul(julls(nls),fdate)
      if (ml.lt.2) print '(a,i4,2i3.2a,i6)'
c        <LeapSF>>> iii leap-second events read, last event: yyyy mm dd
     &,' <LeapSF>>> The far end for leap-second dates:       '
     &,fdate,' = MJD ',julls(nls)
      leap_seconds_from_file=nls
      return

 898  lf=index_l_nonblank(fn)
      print '(3a)'
     &,' <LeapSF>T> Something went wrong. Check path/file name ->'
     &,fn(:lf),'<-'
      stop 'ERR: File problem in sasu01.f'

      entry leap_seconds_rebase (jj)
c does not work if jj is before the first
      ml=msglevel_ts(-999)
      i=0
      q1=.false.
      if (jj.lt.0) then
         j=juldat_epoch()
      else
         j=jj
      endif
      do ils=1,nls
         if (j.le.julls(ils)) then
            if (q1) then
               i=i+1
               julls(i)=julls(ils-1)
               leaps(i)=leaps(ils-1)
               q1=.false.
            endif
            i=i+1
            julls(i)=julls(ils)
            leaps(i)=leaps(ils)
         endif
      enddo
      nls=i
      leap_seconds_rebase=nls
      return
      end

      subroutine sas_kalendar (time,jjul,idate,ihms)
c
c Returns Modified Julian date, YYMMDD and HHMMSSFF for time after epoch
c
c ENTRIES:
c
c sas_kalendar_fj (time,fjul,idate,ihms)
c Like above, however returns fjul (real*8) 
c 
      implicit real*8 (a-h,o-z)
      integer idate(3),ihms(4),ia(4)
      logical qes,qe 
      common /ctime/ iep(3),julbas,lsep,qes
c
c This routine is now taking care of DUT leap seconds (changed 2012-07-04)
c The file ~/Ttide/etgtab/ttutcf.dat lists the dates where a leap second
c is injected at the beginning. 
c 
      qe=.false.
      goto 1
     
      entry sas_kalendar_fj (time,fjul,idate,ihms)
      qe=.true.

 1    if (.not.qes) then
         print '(a)',' <SasKal>T> Epoch not set'
         stop
      endif

      ml=msglevel_ts(-999)
      is=2
      j=julbas+idint(time/24.d0) ! +1.d-8)
      if (ml.lt.1) print *,'<SasKal>d> JULBAS,TIME,J=',julbas,time,j
c
c if time/24.d0 is within 0.5/86400 of  1  look whether the day before
c was a DUT-day
c 
      round=1.d0/86400.d0

      if (j.le.julbas) then
         isls=0
      else
         isls=is_leap_second_jul(j-1)
      endif
      if (ml.lt.1) print *,'<SasKal>d> Is ',j-1
     &,' a day with a leap-second ?',isls,' qes=',qes
      if (isls.ne.0) then
         crit=dmod(time/24.d0+round,1.d0)-round
         if (ml.lt.1) print *,'<SasKal>d> time,crit, round: '
     &,time,crit,round/2.d0
         if (dabs(crit).lt.round/2.d0)
     &   then
            j=j-1
            call leap_second_hms(isls)
            if (ml.lt.1) print *,'<SasKal>d> leap_second_hms ',isls
         else
            call leap_second_hms(0)
            if (ml.lt.1) print *,'<SasKal>d> leap_second_hms 0'
         endif
      endif
      jul=j
      ls=leap_second_jul(jul,isls)
      ls=ls-lsep
      t=time-ls/3.6d3
      j=julbas+idint(t/24.d0) ! +1.d-8)

      if (time.lt.0.d0) j=j-1
c      t=time
      if (t.lt.0.d0) then
         jj=idint(-t/24.d0)+1
         t=t+jj*24.d0
         if (ml.lt.1) print *,'<SasKal>d> t<0, korr: add ',jj*24
     &,                       ' to t=',t-jj*24.d0
      endif
c      ls=leap_second_jul(jul,isls)
      if (ml.lt.1) print *,'<SasKal>d> J, JUL, ISLS, LS, LSEP: '
     &,                    j, jul, isls, ls,lsep
 
      tm=t ! -ls/3.6d3
      if (isls.gt.0) then
         j=jul
      else
         jul=j
      endif

c      tm=t-ls/3.6d3
 103  if (tm.gt.24.d0) then
         tm=tm-24.d0
         goto 103
      endif
c
      call datjul(j,ia)
      do 101 i=1,3
101   idate(i)=ia(i)
      if (ml.lt.1) print *,'<SasKal>d> tm=',tm
      call hms(tm,ia,is)
      ia(1)=mod(ia(1),24)
      do 102 i=1,4
102   ihms(i)=ia(i)
      if (qe) then
       hfe=hours_from_epoch(idate,ihms)
       if (ml.lt.1) print *,'<SasKal>d> HFE, LS, LS[h] ='
     &,             hfe,ls,ls/3.6d3
       fjul=jul+dmod((hfe+ls/3.6d3)/24.d0 + 10000.d0, 1.d0)
      else
        jjul=jul
      endif
      return
      end

      integer function msglevel_ts (msg)
      common /cmsgts/ msglvl,msgcount
      if (msg.ge.0) msglvl=msg
      msglevel_ts=msglvl
      return
      end

      block data bmsgts
      common /cmsgts/ msglvl,msgcount
      data msglvl/2/, msgcount/100/
      end
      
      subroutine print_hfemsg (str)
      character str*(*)
      common /cmsgts/ msglvl,msgcount
      ls=index_l_nonblank(str)
      print '(a)',str
      msgcount=max0(0,msgcount-1)
      return
      
      entry max_hfemsg (j)
      msgcount=j
      return
      end

      real*8 function hours_from_epoch (idate,ihms)
c
c Returns the number of hours from the given date+time w.r.t. 
c the stored epoch. 
c ihms(4) - integer - HH MM SS FFF (FFF = milliseconds)
c
      implicit real*8 (a-h,o-z)
      logical qes
      integer idate(3),ihms(4)
      character str*180
      common /ctime/ iep(3),julbas,lsep,qes
      common /cmsgts/ msglvl,msgcount
      data mk/3/

      if (.not.qes) then
         print *,'<HFEpoc>T> Epoch not set.'
         stop
      endif
      jul=juldat(idate)
      juld=jul-julbas
      ls=leap_second_jul(jul,isls)
      if (msglvl.lt.1) 
     &   print *,'<HFEpoc>d> jul idate ihms ls,lsep,isls='
     &,jul,idate,ihms,ls,lsep,isls
      t=thms(ihms,2)
      if (msglvl.lt.1) 
     &   print *,'<HFEpoc>d> ihms thms, ls, lsep=',ihms,t,ls,lsep
      
      t=t+juld*24.d0+(ls-lsep)/3.6d3
      if (ls-lsep.gt.0.and.mk.gt.0.and.msglvl.le.1) then
         print *
     &,'<HFEpoc>>> Leap-second injected. t, jul idate ls,lsep='
     &,    t,tt,jul,idate,ls,lsep
         mk=mk-1
      endif
      hours_from_epoch=t
      if (msglvl.lt.1.and.msgcount.gt.0) then
         str=' <HFEpoc>d> MJD,t='
         ks=index_l_nonblank(str)
         write (str(ks+1:),*) jul,t
         ks=index_l_nonblank(str)
         str(ks+1:)=' ls,lsep,isls='
         ks=index_l_nonblank(str)
         write (str(ks+1:),*) ls,lsep,isls
         call print_hfemsg (str)
      endif
      return
      end

      real*8 function hours_from_epoch_t (idate,tt)
c
c Returns the number of hours from the given date+time w.r.t. 
c the stored epoch. 
c tt (real*8) is in hours
c
      implicit real*8 (a-h,o-z)
      logical qes
      integer idate(3)
      character str*180
      common /ctime/ iep(3),julbas,lsep,qes
      common /cmsgts/ msglvl,msgcount
      data mk/3/
      if (.not.qes) then
         print *,'<HFEpoc>T> Epoch not set.'
         stop
      endif
      jul=juldat(idate)
      juld=jul-julbas
      ls=leap_second_jul(jul,isls)
      t=tt+dfloat(juld)*24.d0+(dfloat(ls-lsep)+1.d-4)/3.6d3
      if (ls-lsep.gt.0.and.mk.gt.0.and.msglvl.le.1) then
         print *
     &,'<HFEpoT>>> Leap-second injected. t, jul idate ls,lsep='
     &,    t,tt,jul,idate,ls,lsep
         mk=mk-1
      endif
      hours_from_epoch_t=t

      if (msglvl.lt.1.and.msgcount.gt.0) then
         str=' <HFEpoT>d> MJD,t, tt='
         ks=index_l_nonblank(str)
         write (str(ks+1:),*) jul,t,tt
         ks=index_l_nonblank(str)
         str(ks+1:)=' ls,lsep,isls='
         ks=index_l_nonblank(str)
         write (str(ks+1:),*) ls,lsep,isls
         call print_hfemsg (str)
      endif
      return
      end

      real*8 function hours_from_epoch_jt (jul,tt)
c
c Returns the number of hours from the given Mod.Jul.date+time w.r.t. 
c the stored epoch. 
c tt (real*8) is in hours
c
      implicit real*8 (a-h,o-z)
      logical qes
      character str*180
      integer idate(3)
      common /ctime/ iep(3),julbas,lsep,qes
      common /cmsgts/ msglvl,msgcount
      data mk/3/

      if (.not.qes) then
         print *,'<HFEpoc>T> Epoch not set.'
         stop
      endif
      call datjul (jul,idate)
      juld=jul-julbas
      ls=leap_second_jul(jul,isls)
      t=tt+dfloat(juld)*24.d0+(dfloat(ls-lsep)+1.d-5)/3.6d3
      if (ls-lsep.gt.0.and.mk.gt.0.and.msglvl.le.2) then
         print *
     &,'<HFEpJt>>> Leap-second injected. t, tt, jul idate ls,lsep='
     &,    t,tt,jul,idate,ls,lsep
         mk=mk-1
      endif
      hours_from_epoch_jt=t

      if (msglvl.lt.1.and.msgcount.gt.0) then
         str=' <HFEpJt>d> MJD,t='
         ks=index_l_nonblank(str)
         write (str(ks+1:),*) jul,t
         ks=index_l_nonblank(str)
         str(ks+1:)=' ls,lsep,isls='
         ks=index_l_nonblank(str)
         write (str(ks+1:),*) ls,lsep,isls
         call print_hfemsg (str)
      endif
         
      return
      end

      subroutine nice_time_units (t0r,tunits)
c
c t0r - real*8 - in/out - time variable in hours [h]
c                         Will be scaled to [s] if < 0.1 h
c                                           [d] if > 24 h
c                                           [y] if > 1000 h
c                                     else  [h]
c tunits - char** - out - the [.] string with the unit.
c

      character tunits*(*)
      real*8 t0r

      if (dabs(t0r).gt.1d24) then
         t0r=1
         tunits='INF'
         return
      endif
      tunits='[h]'
      if (dabs(t0r).lt.0.5d0) then
         t0r=t0r*3600.d0
         tunits='[s]'
      else if (dabs(t0r).gt.23.5d0) then
         t0r=t0r/24.d0
         tunits='[d]'
         if (dabs(t0r).gt.364.d0) then
            t0r=t0r/365.25d0
            tunits='[y]'
         endif
      endif
      return
      end

      subroutine nice_freq_units (t0r,tunits,opt)
      character tunits*(*),opt*(*)
      real*8 t0r

      if (index(opt,'mHz').gt.0) then
         t0r=t0r/3.6d0
         tunits='[mHz]'
         return
      endif
c      print *,'<NiFrUn>>> f  in:',t0r
      tunits='[cyc/h]'
      if (dabs(t0r).gt.3000.d0) then
         t0r=t0r/3600.d0
         tunits='[Hz]'
      else if (t0r.gt.999.9d0) then
         t0r=t0r/1.d3
         tunits='[kcyc/h]'
      else if (dabs(t0r).lt.0.3333333d0) then
         t0r=t0r*24.d0
         tunits='[cyc/d]'
         if (dabs(t0r).lt.1.d0/36.d0) then
            t0r=t0r*365.25d0
            tunits='[cyc/yr]'
         endif
      endif
c      print *,'<NiFrUn>>> f out:',t0r
      return
      end
      


      block data btime
      logical qes
      common /ctime/ iep(3),julbas,lsep,qes
      data lsep/0/,qes/.false./
      end

C:Provides  subroutine set_epoch F=sasu01.f
C:Provides  subroutine sas_kalendar F=sasu01.f
C:Provides  subroutine print_hfemsg F=sasu01.f
C:Provides  subroutine nice_time_units F=sasu01.f
C:Provides  entry drop_epoch F=sasu01.f
C:Provides  entry new_epoch F=sasu01.f
C:Provides  entry get_epoch F=sasu01.f
C:Provides  entry leap_second_jul F=sasu01.f
C:Provides  entry is_leap_second_jul F=sasu01.f
C:Provides  entry leap_second_scan F=sasu01.f
C:Provides  entry leap_seconds_from_file F=sasu01.f
C:Provides  entry sas_kalendar_fj F=sasu01.f
C:Provides  entry max_hfemsg F=sasu01.f
C:Provides  logical function epoch_set F=sasu01.f
C:Provides  integer function juldat_epoch F=sasu01.f
C:Provides  integer function leap_second F=sasu01.f
C:Provides  integer function msglevel_ts F=sasu01.f
C:Provides  real*8 function hours_from_epoch F=sasu01.f
C:Provides  real*8 function hours_from_epoch_t F=sasu01.f
C:Provides  real*8 function hours_from_epoch_jt F=sasu01.f
C:Provides  block data bmsgts F=sasu01.f
C:Provides  block data btime F=sasu01.f
