      integer function make_decent (s,u)
c
c replaces characters in s that are outside the printable range 
c (ascii 32..255) with u
c If and unprintable u is specified, nothing is replaced.
c
c The routine returns the position immediately before the 
c first undecent character 
c 
      character s*(*),u*1
      logical qq

      l=index_l_nonblank(s)
      j=l+1
      qq=ichar(u).ge.32.and.ichar(u).le.255

      do i=l,1,-1
         if (ichar(s(i:i)).lt.32.or.ichar(s(i:i)).gt.127) then
            if (qq) s(i:i)=u
            j=i
         endif
      enddo
      make_decent=j-1
      return
      end

      integer function loccar (a,n,s)
      character*(*) a(n),s

      do i=1,n
         if (index(a(i),s).eq.1) then
            loccar=i
            return
         endif
      enddo
      loccar=0
      return
      end

      integer function kpos_word (c,kr)
      character c*(*)
      logical qw,qq

      qw=.false.
      kw=1
      k2=2*kr-1
      l=len(c)
      i=index_1_nonblank(c)-1

 1    i=i+1
      if (i.gt.l) then
         kpos_word=0
         goto 9
      endif
      qq=c(i:i).eq.' '
      if (qq.neqv.qw) kw=kw+1
      qw=qq
      if (kw.eq.k2) then
         kpos_word=i
         goto 9
      endif
      goto 1

 9    return
      end

      logical function q_index (str1,str2,iq)
c Strings * logical index function
c>
c Returns true if str2 is a substring of str1, and iq its position
c_
      character str1*(*),str2*(*)
      iq=index(str1,str2)
      q_index=iq.gt.0
      return
      end

      logical function qu_index (str1,str2,iq,qc)
c Strings * logical index function
c>
c Returns true if str2 is a substring of str1, and iq its position
c Ignores case of str1. Therefore:
c str2 must be upper case on call !
c Limitation: str2 max 32 length 
c_
      character str1*(*),str2*(*), str3*32
      logical q,qc,q_index
      
      iq = index(str1,str2)
       q = iq.gt.0
      qu_index = q
      if (q.or..not.qc) return
      
      l1=len(str1)
      l2=min0(len(str2),32)
      if (l2.gt.l1) return

      do i=1,l1,33-l2
         str3=str1(i:i+31)
         l3=min0(32,l1-i+1)
         call ucase (str3,str3)
         if (q_index(str3(:l3),str2(:l2),iq)) then
            iq=iq+i-1
            qu_index=.true.
            return
         endif
      enddo

      return
      end

      logical function qor_index (str1,str2,iq)
c Strings * logical function index(str1,str2(j:j)), j=1..length
c>
c Returns true if any character of str2 is in str1.
c iq is the position of the first character of str2 that also is in str1.
c_
      character str1*(*),str2*(*)
      logical q, q_index
      q=.false.
      l2=len(str2)
      iq=0
101   iq=iq+1
      q=q.or.q_index(str1,str2(iq:iq),j)
      if ((.not.q).and.iq.lt.l2) goto 101
      qor_index = q
      if (.not.q) iq=0
      return
      end

      logical function ql_index (str1,str2,ip)
c Strings * logical function index(str1,str2(j:j)), j=1..length
c>
c Returns true if any character of str2 is in str1.
c ip is the position of the first character of str1 that also is in str2.
c_
      character str1*(*),str2*(*)
      logical q, q_index
      q=.false.
      l2=len(str2)
      iq=0
101   iq=iq+1
      q=q.or.q_index(str1,str2(iq:iq),j)
      if ((.not.q).and.iq.lt.l2) goto 101
      ql_index = q
      if (q) then
         ip=index(str1,str2(iq:iq))
      else
         ip=0
      endif
      return
      end

      integer function ior_index (str1,str2,iq)
      character str1*(*),str2*(*)
      logical qor_index,q
      q=qor_index (str1,str2,iq)
      if (iq.gt.0) then
         ior_index=index(str1,str2(iq:iq))
      else
         ior_index=0
      endif
      return
      end

      logical function quch_in (ch,str,i)
c Strings * logical function ucase(ch) == element of ucase(str)
c>
c Returns true if UCASE$(ch) is in UCASE$(str). Returns position in I
c
c CH - char** - less than 32 long
c_
      character ch*(*), str*(*), tch*32, tstr*32

      quch_in=.false.
      i=0
      lch=len(ch)
      lstr=len(str)
      if (lch.gt.lstr) return
      if (lch.eq.0) then
         quch_in=.true.
         return
      elseif (lch.eq.1) then
         if (ichar(ch(1:1)).lt.32) then
            quch_in=.true.
            return
         endif
      endif
      lch=min0(32,lch)

      tch=ch(:lch)
      call ucase (tch(:lch),tch)
      l=lch-1
      do 101 j=1,lstr-l
      call ucase (str(j:j+l),tstr)
c      print *,' >q> ->',str(j:j+1),'<->',tch(:lch),'<-'
      if (tstr(:lch).eq.tch(:lch)) then
         i=j
         quch_in=.true.
         return
      endif
101   continue
      return
      end

      logical function qucss (a,str,delim,ia,ja,is)
c Strings * Like quch_in, find delimited substrings of a in str
c>
c Example:
c qucss('a|b|cde|fg',STRING,'|',IA,JA,IS)
c returns .true.  if 'a' in STRING or 'A' in string
c                 or 'b' ...
c                        ... or 'FG' in string
c
c A        - char**  - delimited list of codewords .
c DELIM    - char*1  - delimiter
c IA,JA,IS - integer - string positions, returned.
c
c IA,JA,IS : while resolving delimiters, set  SUBSTRING := A(IA:JA).
c First encounter  IS := index(STRING,SUBSTRING)
c
c That means: If qucss returns .true., codeword A(IA:JA) has been found 
c in STRING at position IS.
c_
      character a*(*),str*(*),delim*1
      logical q,quch_in
      q=.false.
      la=index_l_nonblank(a)
      k=1
      is=0
      ia=la+1
      ja=la

1     l=index(a(k:),delim)+k-2
      if (l.lt.k) l=la
      ll=l-k+1
      if (ll.gt.0) then
         q = quch_in (a(k:l),str,j)
         if (q) then
            qucss=.true.
            is=j
            ia=k
            ja=l
            return
         endif
      endif
      k=l+2
      if (k.gt.la) then
         qucss=.false.
         return
      endif
      goto 1
      end

      logical function q_substring (buff,prm,delims,word,lp,lw)
c Strings * Extract an indicated word from a string 
c
c buff   - char** - Input string. 
c prm    - char** - The left delimiter, e.g. ' P=', taking the role of the
c                   name of a parameter.
c             '^' - special value: return the first part of buff up to
c                   one of the indicated delimiters. 
c delims - char** - A collection of possible right delimiters. If none can be
c                   found the whole part of buff after 'P=' is returned. 
c                   The delimiter list is processed left-to-right, escaped
c                   at first encounter. 
c word   - char** - The indicated substring, returned.
c ip     - integer- its starting position, returned.
c lw     - integer- its length, returned.
c
c THE OPPOSITE IS CURRENTLY TRUE!!!
c                   -9999 on call: the 'word' is decided by the earliest 
c                                  element of 'delims' that is found beyond
c                                  'prm' in 'buff'. 
c                            else: the 'word' is the shortest possible within 
c                                  the given 'prm' 'delims'.
c
c Iff prm is not found in buff then q_substring is returned .false.
c Also, the returned parameters are unaffected.
c
c Example: Let buff='lmnxyz P=abcxyz] L=mnoxyz] M=fghxyz$'
c
c q_substring (buff,'P=',']',word,ip,iw) returns .true. and
c              word -> 'abcxyz', ip -> 10, iw -> 6
c
c q_substring (buff,'P=','$',word,ip,iw) returns .true. and
c              word -> 'abcxyz] L=mnoxyz] M=fghxyz', ip -> 10, iw -> 26
c
c q_substring (buff,'R=','$',word,ip,iw) returns .false. 
c
c
c Example:
c This section of code replaces environment variable sybols in a string
c by their value, using UNIX system function getenv:
c 
c 188  j=-9999
c      if (q_substring(rstr,'${','} ',envstr,i,j)) then
c         lei=index(envstr//' ',' ')-1
c         call getenv (envstr(:lei),envout)
c         leo=index(envout//' ',' ')-1
c         call replace_in_string 
c     &       (rstr,'${'//envstr(:lei)//'}',envout(:leo),i-2,0)
c         goto 188
c      endif
c 189  j=-9999
c      if (q_substring(rstr,'$','./$- ',envstr,i,j)) then
c         lei=index(envstr//' ',' ')-1
c         call getenv (envstr(:lei),envout)
c         leo=index(envout//' ',' ')-1
c         call replace_in_string 
c     &           (rstr,'$'//envstr(:lei),envout(:leo),i-1,0)
c         goto 189
c      endif
c
c _ end example
c
      character buff*(*), prm*(*), delims*(*), word*(*), s*1
      logical q, qe, qu_index, qu_substring
      qe=.false.
      goto 1

      entry qu_substring (buff,prm,delims,word,lp,lw)
      qe=.true.
 1    lprm=len(prm)
      if (prm.eq.'^') then
         ip=1
         q=.true.
         lprm=0
      else
         q=qu_index(buff,prm,ip,qe)
      endif
cc      print *,'<QSubst>>> loc at ->',prm(:lprm),'<- ip,q=',ip,' ',q
      kwm=len(buff)
      if (q) then
         ip=ip+lprm
         lp=ip
         l=len(delims)
         do 101 i=1,l
            s=delims(i:i)
            kw=index(buff(ip:),s)+ip-2
ccccccccccccccccccccccccccccccccccccccccccc new:
            if (kw.gt.ip-2) then
               if (lw.ne.-9999) then
                  kwm=kw
                  goto 102
               else
                  kwm=min0(kwm,kw)
               endif
            endif
c ccccccccccccccccccccccccccc old:   if (kw.gt.ip-2) goto 102
 101     continue
c ccccccccccccccccccccccccccc old:     kwm=len(buff)
 102  word=buff(ip:kwm)
cc      print *,'<QSubst>d> returns ->',buff(ip:kwm),'<-'
      lw=min0(len(word),kwm-ip+1)        
      endif
      if (qe) then
         qu_substring=q
      else
         q_substring=q
      endif
      kw=kwm
      return
      end

      integer function next_word (str,d,word,ip,lw)
c
c Typical application:
c      ip=0
c 101  print *,next_word(str,d,word,ip,lw),ip,' ->',word(:lw),'<-'
c      if (ip.gt.0) goto 101
c
c
c str*(*) - string to be analysed
c d*(*)   - delimeter
c word    - the next word in the string
c
c ip      - input output  does             what? 
c           ---------------------------------------------------------------
c             0    i      reset;           on return, ip=i is the position
c                                          of the next delimiter
c                                          (which could be 1+length(str)
c                                          if it's the last word)
c
c             i    i+j   continue at i+1;  ip=i+j is the ....
c
c            ls+i  0     almost nothing    ls=length(str). Do nothing
c                                          except return ip=0
c
c lw      - length(word)
c
c next_word  returned value: is normally the count of words since the last time 
c ip was <= 0 . When the last word has been found, next_word returns 0
c If ip > length(str), next_word returns -1.
c
c Hence, if str contains only one word, e.g. 'adas/home/hgshgsadasd'
c    ip=0
c    ier=next_word(str,';',word,ip,lw)
c the result will be ier=0, ip=22, lw=21 
c
c Example with the "typical" code sample above and delimiter '/':
c str='adas/home/hgshgsadasd'
c
c  IER LP    WORD
c   1   5  ->adas<-
c   2  10  ->home<-
c   0  22  ->hgshgsadasd<-
c  -1   0  -><-
c
c See util/afor/p/m/tstrepenv.f
c
      character str*(*),word*(*),d*(*)
      data kount/0/

      if (ip.le.0) then
         ip=0
         kount=0
      endif

      ls=index_l_nonblank(str)
      ld=max0(1,index_l_nonblank(d))
      if (ip.gt.ls) then
         next_word=-1
         word=' '
         lw=0
         ip=0
         return
      endif
      i=index(str(ip+1:ls),d(:ld))+ip+ld

      if (i.le.ip+ld) then
         word=str(ip+1:ls)
         next_word=0
         lw=ls-ip
         ip=ls+1
         return
      endif

      word=str(ip+1:i-ld-1)
      lw=i-ld-ip-1
      ip=i-1
      kount=kount+1
      next_word=kount
      return
      end
      
      integer function nth_word (i,str,d,word,ip,lw)
c
c i     integer  input   position of requested word
c str   char*(*) input   string to be analysed
c d     char*(*) input   delimiter
c word  char*(*) output  the word
c ip    integer  output  position of next word in STR or 0 if exhausted 
c lw    integer  output  length of word
c
c
c i<=0: returns in WORD the last word of str; ip=length(STR)+1
c
c i>0:  returns in WORD the i'th or the last word of STR
c       On return, IP=0 if it's the last word
c 
c function value returned:
c i     if the i'th word was found
c j<i   if j was the last word when the i'th word was requested 
c 0     if it was the last word
c
      character str*(*),d*(*),word*(*)
      
      ip=0
 101  ier=next_word(str,d,word,ip,lw)
      if (ier.eq.0) then
         nth_word=i
      else
         nth_word=ier
      endif
      if (ier.eq.i.or.i.lt.0) return
      if (ier.le.0) then
         ip=0
         return
      endif
      goto 101
      end

      integer function nth_real_word (i,str,d,word,ip,lw)
c
c this routine calls nth_word so long that multiple delimiters
c are skipped
c Thus   nth_real_word (2,'   a   b ',' ',word,ip,lw)
c                          ___ ___
c will result in
c word='b' 
c ier=0      ! words exhausted now
c ip=0       ! next position n/a
c lw=1       ! length of word
c
c and   nth_real_word (2,'   a   bb c',' ',word,ip,lw)
c                        123456789
c word='b'
c ier=3      ! there is another word
c ip=10      ! word is string(ip-lw:ip)
c lw=2       ! length of word
c
      character str*(*),d*(*),word*(*)

      k=0
 102  ier=nth_word (i+k,str,d,word,ip,lw)
      if (lw.le.0.and.ip.gt.0) then
         k=k+1
         goto 102
      endif
      if (ip.le.0) ier=k-1
      nth_real_word=ier-k+1
      return
      end

      subroutine split_into_words (str,d,q0l,words,i)
c
c Input: STR, D, Q01
c 
c Example:
c Splits str 'a,b,c'  into words(1)='a' etc. (here, d=delimiter = ',')
c 
c str - char** -   string of characters
c d   - char*1 -   delimiter
c 
c q0l = .true.:    Splits str 'a,,b,c' into words  'a' '' 'b' 'c'
c q0l = .false.:   Splits str 'a,,b,c' into words  'a' 'b' 'c'
c
c Returns WORDS = array of characters, and I = number of words
c
      character str*(*),words*(*),d*(*)
      dimension words(*)
      logical q_substring,q0l
      
      ls=index_l_nonblank(str)
      i=0
      k=index(str,d)
      if (k.eq.0) then
         i=1
         words(1)=str
         return
      endif
      if (k.gt.0) then
         i=i+1
         words(i)=str(:k-1)
      endif

 1    i=i+1
      if (index(str(k:ls),d).le.0) then
         if (k.le.ls) then
            words(i)=str(k:ls)
         else
            i=i-1
         endif
         return
      endif
      if (q_substring(str(k:),d,d,words(i),j,lw)) then
         if (lw.le.0.and..not.q0l) i=i-1
         k=k+j+lw
         goto 1
      else
         k=k+1
         if (k.lt.ls) goto 1
      endif
      print *,'<SpWord>E> String exhausted. k, length = ',k,ls
      return
      end

      double precision function d_substring 
     &                 (buff,default,prm,delims,word,lp,lw,qv)
c
c d=d_substring('hello,123.4d0]',3.14d0,',','] ',word,lp,lw,qv)
c returns 123.4d0, qv=.true. on return, word set
c
c d=d_substring('hello,]',3.14d0,',','] ',word,lp,lw,qv)
c returns 3.14d0,  qv=.true. on return, word set  (read end)
c
c d=d_substring('hello,buddy]',3.14d0,',','] ',word,lp,lw,qv)
c returns 3.14d0,  qv=.false. on return, word set (read error)
c
c d=d_substring('hello buddy]',3.14d0,',','] ',word,lp,lw,qv)
c returns 3.14d0,  qv=.false. on return, word not set (delimiter not found)
c
c (one could think of returning two logicals, qv,qr
c qv would signal whether q_substring was successful,
c qr whether reading was successful
c However, lp and lw can be tested.)
c
      character buff*(*), prm*(*), delims*(*), word*(*)
      logical q_substring,qv
      real*8 default,d
      d=default
      qv=q_substring(buff,prm,delims,word,lp,lw)
      if (qv) read (word,*,err=1,end=2) d
 2    d_substring=d
      return
 1    d_substring=d
      qv=.false.
      return
      end

      function r_substring (buff,default,prm,delims,word,lp,lw,qv)

      character buff*(*), prm*(*), delims*(*), word*(*)
      logical q_substring,qv
      d=default
      qv=q_substring(buff,prm,delims,word,lp,lw)
      if (qv) read (word,*,err=1,end=2) d
 2    r_substring=d
      return
 1    r_substring=d
      qv=.false.
      return
      end

      function i_substring (buff,default,prm,delims,word,lp,lw,qv)

      integer d,default
      character buff*(*), prm*(*), delims*(*), word*(*)
      logical q_substring,qv
      d=default
      qv=q_substring(buff,prm,delims,word,lp,lw)
      if (qv) read (word,*,err=1,end=2) d
 2    i_substring=d
      return
 1    i_substring=d
      qv=.false.
      return
      end

      logical function qr_substring (buff,prm,delims,word,iw,lp,lw,r)
      character buff*(*),prm*(*),delims*(*),word*(*)
      real*8 d
      logical qd_substring 
      call replace_in_string (word,'d','e',1,0)
      qr_substring=qd_substring(buff,prm,delims,word,iw,lp,lw,d)
      r=d
      return
      end
      
c
      logical function qd_substring (buff,prm,delims,word,iw,lp,lw,r)
c
c here we try to extract a real number in exp-format or straight
c in so comlicated expressions as in 
c +123e+1-1d-2/8
c legal exponent symbols are E e D d & ^ 
c
c The first number in buff will be extracted and returned as r (real*8)
c Use qr_substring to get it in real*4
c
c prm locates the start of the string to be analysed: immediately after
c     Can be '' for no prm
c
c delims is a set of delimiters in addition to ;,:/*#%(){}=£€<>[]$
c        (they get higer priority). Can be ''
c
c word returned: word(1:iw) contains any leading delimiters
c word starts at buff(lp:) and is lw long
c If word contains & or ^ (exponent symbols) they are replaced with d
c (or e if qr_substring is used)
c
c Returned value is .false. if the word(iw+1:) cannot be read 
c with read (word(iw+1:),*) rval
c
c In order to obtain an array of numbers:
c       ib=1
c       j=0
c       ls=index_l_nonblank(str)
c 101   q=qd_substring (buff,prm,delims,word,iw,lp,lw,r(j+1))
c       ib=ib+lp+lw-1
c       j=j+1
c       if (ib.lt.ls) goto 101
c
c if (qd_substring (buff,'','',word,iw,lp,lw,r)) then
c    if (word(1:1).eq.'/') r=1.d0/r
c else
c    r=default
c endif
c
c 
c
      character buff*(*),prm*(*),delims*(*),word*(*), delimu*64
      real*8 r
      logical qor_index

      lb=index_l_nonblank(buff)
      lp=index_l_nonblank(prm)
      ld=index_l_nonblank(delims)
      delimu=delims
      delimu(ld+1:)=';,:/*#%(){}=<>[]$'
      ld=index_l_nonblank(delims)

      ib=index(buff,prm(:lp))+lp
      i=ib
      iw=0
 103  if (qor_index(delims(:ld)//';,:/*#%(){}=£€<>[]$'
     &,   buff(ib+iw:ib+iw),iq)) then
         iw=iw+1
         goto 103
      endif
      ib=ib+iw
      
      ie=ior_index(buff(ib:),delimu(:ld),iq)
     &   +ib-2
c      print *,'d0:',ie,ib,iq
      if (ie.le.ib-2) ie=lb
c      print *,'d1:',i,ib,ie,iq,iw
 101  icp=index(buff(ib+1:),'+')+ib
c      print *,'d2p:',ib,icp
      icm=index(buff(ib+1:),'-')+ib
c      print *,'d2m:',ib,icp
      if (icp.le.ib.or.icm.le.ib) then
         ic=max0(icm,icp)
      else
         ic=min0(icm,icp)
      endif
c      print *,'d3:',ic,' ',buff(ic-1:ic-1)
      if (ic.gt.ib) then
         if (index('&eEdD',buff(ic-1:ic-1)).gt.0) then
            ib=ic+1
            goto 101
         endif
         ic=ic-1
      else
         ic=lb
      endif
c      print *,'d4:',ib,ic,i,ie
      ie=min0(ic,ie)
      word=buff(i:ie)
      call replace_in_string (word(iw+1:),'&','d',1,0)
      call replace_in_string (word(iw+1:),'^','d',1,0)
      lp=i
      lw=ie-i+1
      read (word(iw+1:),*,end=901,err=901) r
      qd_substring=.true.
      return
      
 901  lw=index_l_nonblank(word)
c      print *,'<QrSub>E> Reading failed: ',word(iw+1:lw)
      qd_substring=.false.
      return
      end
      

         
            
