      subroutine set_tide_type (n,c,u)
c
c Set/retrieve information: number of (active) components and commentary text.
c
c N    - integer - Number of components with ocean loading
c C    - char**  - Max 16 signif.chars - observation type (e.g. 'Displacement')
c U    - char**  - Max 8  signif.chars - measurement units (e.g. '[m]')
c
c      Entry Get_Tide_Type (n,c,u) - retrieve.
c
c      Entry Set_Active_comp (NA)
c
c NA   - integer - Number of components included in the do-loops of
c                  DISPLACEMENT_TIDE, AVE_TIDE, BL_Z (elaelle.f)
c                  TIDE_AT_TIME (ttims.f)
c
c      Integer Function Inq_Active_Comp () <- NA   - retrieve
c
c ____________________________________________________________________________
c
c NCOMP is usually assigend by OCEAN_LOAD_TIDE, depending on the
c     number of components in the table.
c 
c Set_Tide_Type is an entry for the system. To reset the text strings for
c observation types and measurement units,
c     Call Set_Tide_Type(-1,component_text,units_text)
c which does not change the current setting for N.
c
c If the number of components is to be reduced from 3 to 1 ,
c     Call SET_ACTIVE_COMP(1)
c
c
      character c*(*),u*(*)
      character tity*32,units*32
      common /cctity/ tity,units
      common /ctity/ ncomp,mcact

      if (n.ge.0) ncomp=n
      tity=c
      units=u
      return

      entry set_active_comp (i)
      mcact=i
      return

      entry get_tide_type (n,c,u)
      n=ncomp
      c=tity
      u=units
      return
      end

      integer function inq_active_comp()
      character tity*32,units*32
      common /cctity/ tity,units
      common /ctity/ ncomp,mcact
c      print *,'<inqaco>d> ncomp,mcact=',ncomp,mcact
      inq_active_comp=mcact
      return
      end

      block data btity
      character tity*32,units*32
      common /cctity/ tity,units
      common /ctity/ ncomp,mcact
      data tity/'Displacement '/, units/'[m]'/, ncomp/3/, mcact/3/
      end
