      subroutine tt_utc_f (djds,dut)
c
c Loads DUT from a file, returns the DUT[s] for the requested date 
c djds (long Julian).
c
c The file on unit iun can be preconnected. Otherwise, if this 
c routine is to open the file, the name must be announced using 
c     call tt_utc_file (iun,filename) 
c initially. iun can be set to 0 to default to the hard-wired UTC
c program of Wenzel. 
c 
c Default filename is ttutcf.dat (specify ' ' to keep)
c
c The file must contain the dates and the leap second introduced at 
c each date. Format YYYY MM DD LL: (i4,3(1x,i2))
c
      implicit real*8 (a-h,o-z)
      character fn*64,cc*(*)
      logical   first,qop
      integer   date(3),olddate(3)
      dimension djd(200),leap(200)
      save      n,djd,leap,iun

      data first/.true./
     &,    fn/'/home/hgs/Ttide/etgtab/ttutcf.dat '/, iun/-1/

 1    if (iun.eq.0) then
         djdsc=djds
         call tdt_utc (djdsc,dutc)
         dut=dutc
         return
      endif        
      if (first) then
        if (iun.le.0) then
         print '(a)'
     &,        ' <TTUTCF>E> DUT-file name and unit undeclared'
     &,        ' <TTUTCF>I> Please, issue CALL TT_UTC_FILE (iun,name)'
     &//       ' in Main pgm.'
     &,        ' <TTUTCF>I> CALL TT_UTC_FILE (0,'' '') to run hardwired'
     &,        ' <TTUTCF>W> Resorting to hardwired default...'
            iun=0
            goto 1
         endif
         inquire (unit=iun,opened=qop)
         if (.not.qop) then
            open (unit=iun,file=fn,status='OLD',form='FORMATTED'
     &,           err=902,iostat=ios)
	    call save_file_name (iun,fn)
         endif
         qop=.true.
      endif  
      dut=42.184d0  ! the value at 1972 01 01

 10   i=0
101   i=i+1
      if (first) then ! read whole table
         read (iun,'(i4,3(1x,i2))',end=901,err=903,iostat=ios) 
     &        date,leap(i)
         if (date(1).lt.1800.or.date(1).gt.2999) goto 901
         n=i
         call julian (date(1),date(2),date(3),djd(i))
         do j=1,3
            olddate(j)=date(j)
         enddo
         goto 101
      endif
      if (i.gt.n) goto 901
      if (djd(i).gt.djds) goto 100
      dut=dut+leap(i)
      goto 101
     
 100  if (qop) close (iun)
      first=.false.
      return

 901  if (first) then
         n=i-1
         if (idnint(djds-djd(n)).gt.0) 
     &    print '(a,i4,2i3.2,a,i6,a)'
     &,         ' <TTUTCF>W> File ends at ',olddate,', short by '
     &,           idnint(djds-djd(n)),' days.' 
     &,         ' <TTUTCF>I> Last record read: ',n
         first=.false.
         goto 10
      else
         lfn=index(fn//' ',' ')-1
         print '(2a)'
     &,        ' <TTUTCF>W> Beyond end of table, file ',fn(:lfn)

      endif
      goto 100

902   lfn=index(fn//' ',' ')-1
      print '(a,i2,2h ",a,2h",,a,i4)'
     &,     ' <TTUTCF>T> Cannot open ',iun,fn(:lfn),' IOSTAT=',ios
      stop 'due to OPEN ERR in subroutine TTUTCF'

903   lfn=index(fn//' ',' ')-1
      print '(a,i2,2h ",a,2h",,a,i4)'
     &,     ' <TTUTCF>T> Cannot read ',iun,fn(:lfn),' IOSTAT=',ios
      stop 'due to READ ERR in subroutine TTUTCF'

      entry tt_utc_file (ii,cc)
      iun=ii
      if (cc(1:1).ne.' ') fn=cc
      return
      end
