      real*8 function v_2_norm (x)
c returned value = |x|      
      real*8 x(3)
      v_2_norm=dsqrt(x(1)**2+x(2)**2+x(3)**2)
      return
      end

      real*8 function v_2_norm_v (x1,x2,x3)
c returned value = |x|      
      real*8 x1,x2,x3
      v_2_norm_v=dsqrt(x1**2+x2**2+x3**2)
      return
      end

      real*8 function v_length (x1,x2,dx)
      implicit real*8 (a-h,o-z)
      real*8 x1(3),x2(3),dx(3)
      do i=1,3
         dx(i)=x2(i)-x1(i)
      enddo
      v_length = v_2_norm (dx)
      return
      end

      real*8 function v_2_norm_2 (x1,x2)
c returned value = |x2-x1|      
      real*8 x1(3),x2(3)
      v_2_norm_2=dsqrt((x1(1)-x2(1))**2
     &              +(x1(2)-x2(2))**2
     &              +(x1(3)-x2(3))**2)
      return
      end

      subroutine cross_prd (a,b,c)
c c = a x b
c c is returned      
      real*8 a(3),b(3),c(3)
      c(1)=a(2)*b(3)-a(3)*b(2)
      c(2)=a(3)*b(1)-a(1)*b(3)
      c(3)=a(1)*b(2)-a(2)*b(1)
      return
      end

      real*8 function dot_prd (a,b)
c returned value = a . b      
      real*8 a(3), b(3)
      dot_prd = a(1)*b(1)+a(2)*b(2)+a(3)*b(3)
      return
      end

      real*8 function d_dot_prd (a,x, b)
c returned value = (a-x) . b      
      real*8 a(3), b(3), x(3)
      d_dot_prd = (a(1)-x(1))*b(1)+(a(2)-x(2))*b(2)+(a(3)-x(3))*b(3)
      return
      end

      subroutine unit_v (a,b)
c b = a/|a|  
c b is returned      
      real*8 a(3), b(3), an, v_2_norm
      an=v_2_norm(a)
      b(1)=a(1)/an
      b(2)=a(2)/an
      b(3)=a(3)/an
      return
      end

      subroutine basys_sphere (lambda,theta,b)
c b(.,1) is the unit vector r
c b(.,2)                    theta
c b(.,3)                    lambda 
c at colatitude and longitude theta, lambda
c
c theta, lambda input, radians
c b output
c      
      implicit real*8 (a-z)
      dimension b(3,3)
      
      ct=dcos(theta)
      st=dsin(theta)
      cl=dcos(lambda)
      sl=dsin(lambda)
      
      b(1,1)=st*cl
      b(2,1)=st*sl
      b(3,1)=ct

      b(1,2)=ct*cl
      b(2,2)=ct*sl
      b(3,2)=-st
      
      b(1,3)=-sl
      b(2,3)=cl
      b(3,3)=0.0d0
      return
      end
      
      subroutine unit_v_sphere (lambda,theta,j,b)
      implicit real*8 (a-h,l-z)
      dimension b(3)
      
      ct=dcos(theta)
      st=dsin(theta)
      cl=dcos(lambda)
      sl=dsin(lambda)

      if (j.eq.1) then      
         b(1)=st*cl
         b(2)=st*sl
         b(3)=ct
      elseif (j.eq.2) then
         b(1)=ct*cl
         b(2)=ct*sl
         b(3)=-st
      elseif (j.eq.3) then
         b(1)=-sl
         b(2)=cl
         b(3)=0.0d0
      endif
      return
      end
            
C:Provides  subroutine cross_prd F=vec3d.f
C:Provides  subroutine unit_v F=vec3d.f
C:Provides  subroutine basys_sphere F=vec3d.f
C:Provides  subroutine unit_v_sphere F=vec3d.f
C:Provides  real*8 function v_2_norm F=vec3d.f
C:Provides  real*8 function v_2_norm_v F=vec3d.f
C:Provides  real*8 function v_length F=vec3d.f
C:Provides  real*8 function v_2_norm_2 F=vec3d.f
C:Provides  real*8 function dot_prd F=vec3d.f
C:Provides  real*8 function d_dot_prd F=vec3d.f
